'This space reserved for real code.

Global Const CF_SCREENFONTS = &H1&
Global Const CF_PRINTERFONTS = &H2&
Global Const CF_BOTH = &H3&
Global Const CF_SHOWHELP = &H4&
Global Const CF_INITTOLOGFONTSTRUCT = &H40&
Global Const CF_USESTYLE = &H80&
Global Const CF_EFFECTS = &H100&
Global Const CF_APPLY = &H200&
Global Const CF_ANSIONLY = &H400&
Global Const CF_NOVECTORFONTS = &H800&
Global Const CF_NOSIMULATIONS = &H1000&
Global Const CF_LIMITSIZE = &H2000&
Global Const CF_FIXEDPITCHONLY = &H4000&
Global Const CF_WYSIWYG = &H8000&         'must also have CF_SCREENFONTS & CF_PRINTERFONTS
Global Const CF_FORCEFONTEXIST = &H10000
Global Const CF_SCALABLEONLY = &H20000
Global Const CF_TTONLY = &H40000
Global Const CF_NOFACESEL = &H80000
Global Const CF_NOSTYLESEL = &H100000
Global Const CF_NOSIZESEL = &H200000


Global Const HELP_CONTEXT = &H1
Global Const HELP_CONTENTS = &H3

Global Const MAXNODES = 8
Global Const MAXUNIT = 100
Global Const MAXSTEPS = 260
Global Const SSD_RELATIONSHIPS = 20

Global Const VNOTCH60 = 0
Global Const VNOTCH90 = 1
Global Const SCRECT = 2
Global Const BCRECT = 3
Global Const ORIFICE = 4

'Infiltration Types

Global Const SCS_INFILTRATION = 100
Global Const HORTON_INFILTRATION = 101
Global Const PI = 3.14159
' Types of Rainfall

Global Const USER_RAINFALL = 100
Global Const SCSTYPEII_RAINFALL = 101
Global Const SCSTYPEIIFL_RAINFALL = 102
Global Const SCSTYPEIII_RAINFALL = 103
Global Const CONSTANT_RAINFALL = 104

Global Const PROFESSIONAL = 100
Global Const SHAREWARE = 101

Global Const ODD_POND = 0
Global Const SQUARE_POND = 100
Global Const CIRCLE_POND = 101


Type WatershedType
        FileName                    As String * 100
        TotalArea                   As Single
        Label                       As String * 30
        InfMeth                     As Integer
        TimeCon                     As Single
        ImpArea                     As Single
        DCIA                        As Single
        AddAbsImp                   As Single
        AddAbsPerv                  As Single
        MaxInf                      As Single
        HIC                         As Single
        HIO                         As Single
        HK                          As Single
        CN                          As Single
        InitAbs                     As Single
        FracDCIA                    As Single
        FracNDCIA                   As Single
        FracPerv                    As Single
        SmoothFlag                  As Single
End Type

Type WeirType
        Label                           As String * 35
        Equation                        As String * 25
        Type                            As Integer
        NumberSSD                       As Integer
        Invert                          As Single
        Diameter                        As Single
        Width                           As Single
        C                               As Single
        n                               As Single
        
        Stage(SSD_RELATIONSHIPS)        As Single
        Discharge(SSD_RELATIONSHIPS)    As Single
End Type

Type PondType
        FileName                        As String * 100
                                                    ' *** Weir Parameters
        cw                              As Integer
        NumberWeirs                     As Integer
        Weir(2)                         As WeirType

        peakstep                        As Integer
        shape                           As Integer

        minstage                        As Single
        OrigVolume                      As Single
        MinStorage                      As Single
        SurfArea                        As Single
        SSlope                          As Single
        
                                                    ' *** Routing Parameters
        numbersteps                     As Integer
        TimeStep                        As Single
        InitStage                       As Single
        MaxStage                        As Single
        MaxVolume                       As Single
        PeakInflow                      As Single
        PeakOutflow                     As Single
        pstage(MAXSTEPS)                As Single
        inflow(MAXSTEPS)                As Single
        outflow(MAXSTEPS)               As Single
                                                    ' *** SSD Parameters
        NumberSSD                       As Integer
        Stage(SSD_RELATIONSHIPS)        As Single
        Discharge(SSD_RELATIONSHIPS)    As Single
        Storage(SSD_RELATIONSHIPS)      As Single
        srfarea(SSD_RELATIONSHIPS)      As Single
End Type

Type rainfalltype
        FileName                        As String * 100
        Type                            As Integer
        numbersteps                     As Integer
        TimeStep                        As Integer
        Duration                        As Single
        Total                           As Single
        Rain(MAXSTEPS)                  As Single
End Type

Type UnitHydrographType
        FileName                        As String * 100
        numbersteps                     As Integer
        Q(MAXSTEPS)                     As Single
End Type

Type HydrographType
        FileName                        As String * 100
        hydrotype                       As String * 26
        Runoff(MAXSTEPS)                As Single
        infiltration(MAXSTEPS)          As Single
        outflow(MAXSTEPS)               As Single
        TimeCon                         As Single
        TimeStep                        As Single
        RatCoeff                        As Single
        KR                              As Single
        PeakAttFact                     As Single
        hydrosteps                      As Integer
        TotalExcess                     As Single
        TotalRunoff                     As Single
        TotalInfiltration               As Single
        TotalOutflow                    As Single
        PeakOutflow                     As Single
        TotalArea                       As Single
End Type

Global PlotOption As Integer

Global R     As rainfalltype
Global W     As WatershedType
Global H     As HydrographType
Global UH    As UnitHydrographType
Global P     As PondType
Global Version  As Integer

Sub OpenFile (FileType As Integer)
Dim Cancel           As Integer
Dim Success          As Integer
On Error GoTo OpenFileErr

Select Case FileType
   Case 1
      tt$ = "Watershed Files(*.shd)|*.shd"
      DeFile$ = "*.SHD"
      DeExt$ = "SHD"
   Case 2
      tt$ = "Rainfall Files(*.rnf)|*.rnf"
      DeFile$ = "*.RNF"
      DeExt$ = "RNF"
   Case 3
      tt$ = "Hydrograph Files(*.hyd)|*.hyd"
      DeFile$ = "*.HYD"
      DeExt$ = "HYD"
   Case 4
      tt$ = "Pond Files(*.pnd)|*.pnd"
      DeFile$ = "*.PND"
      DeExt$ = "PND"
   Case 5
      tt$ = "Unit Hydrograph Files(*.uhg)|*.uhg"
      DeFile$ = "*.UHG"
      DeExt$ = "UHG"
End Select

main.CMDialog1.FileName = DeFile$
main.CMDialog1.Filter = tt$
main.CMDialog1.FilterIndex = 1
main.CMDialog1.DefaultExt = DeExt$
main.CMDialog1.Action = 1

Select Case FileType
   Case 1
      W.FileName = main.CMDialog1.FileName
      Open W.FileName For Input As #1
      Success = OpenShedFile%(W)
   Case 2
      R.FileName = main.CMDialog1.FileName
      Open R.FileName For Input As #1
      Success = OpenRainFile%(R)
   Case 3
      H.FileName = main.CMDialog1.FileName
      Open H.FileName For Input As #1
      Success = OpenShedFile%(W)
      Success = OpenRainFile%(R)
      Success = OpenHydrFile%(H)
   Case 4
      P.FileName = main.CMDialog1.FileName
      Open P.FileName For Input As #1
      Success = OpenPondFile%(P)
   Case 5
      UH.FileName = main.CMDialog1.FileName
      Open UH.FileName For Input As #1
      Success = OpenUnitFile%(UH)
End Select
Close

If Success Then
    MsgBox (main.CMDialog1.FileName + " File Retrieved")
    
Else
    MsgBox (" File NOT Retrieved")
End If
Exit Sub
OpenFileErr:
   Exit Sub
End Sub

Sub SaveFile (FileType As Integer)
Dim Cancel          As Integer
Dim Success         As Integer

On Error GoTo SaveFileErr
Select Case FileType
   Case 1
      If W.TotalArea = 0 Then Exit Sub
      tt$ = "Watershed Files(*.shd)|*.shd"
      DeFile$ = "WATRSHED.SHD"
      DeExt$ = "SHD"
   Case 2
      If R.numbersteps = 0 Then Exit Sub
      tt$ = "Rainfall Files(*.rnf)|*.rnf"
      DeFile$ = "RAINFALL.RNF"
      DeExt$ = "RNF"
   Case 3
      If H.hydrosteps = 0 Then Exit Sub
      tt$ = "Hydrograph Files(*.hyd)|*.hyd"
      DeFile$ = "HYDRGRPH.HYD"
      DeExt$ = "HYD"
   Case 4
      If P.numbersteps = 0 Then Exit Sub
      tt$ = "Pond Files(*.pnd)|*.pnd"
      DeFile$ = "POND.PND"
      DeExt$ = "PND"
   Case 5
      If UH.numbersteps = 0 Then Exit Sub
      tt$ = "Unit Hydrograph Files(*.uhg)|*.uhg"
      DeFile$ = "UNITHYD.UHG"
      DeExt$ = "UHG"
End Select

main.CMDialog1.FileName = DeFile$
main.CMDialog1.CancelError = True
main.CMDialog1.Filter = tt$
main.CMDialog1.FilterIndex = 1
main.CMDialog1.DefaultExt = DeExt$
main.CMDialog1.Action = 2

FileName$ = main.CMDialog1.FileName
PlaceExtension FileName$, DeExt$

Select Case FileType
   Case 1
      W.FileName = FileName$
      Open W.FileName For Output As #1
      Success = SaveShedFile(W)
   Case 2
      R.FileName = FileName$
      Open R.FileName For Output As #1
      Success = SaveRainFile(R)
   Case 3
      H.FileName = FileName$
      Open H.FileName For Output As #1
      Success = SaveShedFile%(W)
      Success = SaveRainFile%(R)
      Success = SaveHydrFile%(H)
   Case 4
      P.FileName = FileName$
      Open P.FileName For Output As #1
      Success = SavePondFile%(P)
   Case 5
      UH.FileName = FileName$
      Open UH.FileName For Output As #1
      Success = SaveUnitFile%(UH)
End Select
Close

If Success Then
    MsgBox (FileName$ + " Saved")
    
Else
    MsgBox (" File NOT Saved")
End If

Exit Sub
SaveFileErr:
   Exit Sub
End Sub

Sub ShowHelp (HCId As Long)
   main.CMDialog1.HelpCommand = HELP_CONTEXT
   main.CMDialog1.HelpContext = HCId
   main.CMDialog1.HelpFile = "SMADA5.HLP"
   main.CMDialog1.Action = 6

End Sub

