VERSION 2.00
Begin Form PlotForm 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Plot"
   ClientHeight    =   6840
   ClientLeft      =   15
   ClientTop       =   315
   ClientWidth     =   9315
   Height          =   7245
   Left            =   -45
   LinkTopic       =   "Form1"
   ScaleHeight     =   6840
   ScaleWidth      =   9315
   Top             =   -30
   Width           =   9435
   Begin SSCommand cmdGrid 
      Font3D          =   0  'None
      Height          =   975
      Left            =   3720
      Picture         =   PLOTFORM.FRX:0000
      TabIndex        =   7
      Top             =   5760
      Width           =   975
   End
   Begin SSCommand cmdPrint 
      Font3D          =   0  'None
      Height          =   975
      Left            =   1320
      Picture         =   PLOTFORM.FRX:087A
      TabIndex        =   6
      Top             =   5760
      Width           =   975
   End
   Begin SSCommand cmdCopy 
      Font3D          =   0  'None
      Height          =   975
      Left            =   2520
      Picture         =   PLOTFORM.FRX:10F4
      TabIndex        =   5
      Top             =   5760
      Width           =   975
   End
   Begin SSCommand cmdDone 
      Font3D          =   0  'None
      Height          =   975
      Left            =   120
      Picture         =   PLOTFORM.FRX:196E
      TabIndex        =   4
      Top             =   5760
      Width           =   975
   End
   Begin CommandButton cmdRouting 
      Caption         =   "Ro&uting"
      Height          =   495
      Left            =   7920
      TabIndex        =   3
      Top             =   5880
      Width           =   1215
   End
   Begin CommandButton cmdHydrograph 
      Caption         =   "&Hydrograph"
      Height          =   495
      Left            =   6480
      TabIndex        =   2
      Top             =   5880
      Width           =   1215
   End
   Begin CommandButton cmdPlotRainfall 
      Caption         =   "&Rainfall"
      Height          =   495
      Left            =   5040
      TabIndex        =   1
      Top             =   5880
      Width           =   1215
   End
   Begin GRAPH Graph1 
      AsciiFFamily    =   "0"
      AsciiFStyle     =   "0"
      GraphType       =   0  'None
      Height          =   5535
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   9015
   End
End

Sub cmdCopy_Click ()
   Graph1.DrawMode = 4
   Form_Load
End Sub

Sub cmdDone_Click ()
   Unload PlotForm
End Sub

Sub cmdGrid_Click ()
   i% = Graph1.GridStyle
   If i% = 3 Then i% = 0 Else i% = i% + 1
   Graph1.GridStyle = i%
   Graph1.DrawMode = 2
End Sub

Sub cmdHydrograph_Click ()
   If H.hydrosteps = 0 Then Exit Sub
   Graph1.DataReset = 9
   PlotOption = 1: Form_Load
   Graph1.DrawMode = 2
End Sub

Sub cmdPlotRainfall_Click ()
   Graph1.DataReset = 9
   PlotOption = 2: Form_Load
   Graph1.DrawMode = 2
End Sub

Sub cmdPrint_Click ()
   Graph1.DrawMode = 5
   Form_Load
End Sub

Sub cmdRouting_Click ()
   If P.numbersteps = 0 Then Exit Sub
   Graph1.DataReset = 9
   PlotOption = 3: Form_Load
   Graph1.DrawMode = 2
End Sub

Sub Form_Load ()
If PlotOption = 1 Then PlotHydrograph H, R
If PlotOption = 2 Then PlotRainfall R
If PlotOption = 3 Then PlotPondRouting P
End Sub

Sub PlotHydrograph (TH As HydrographType, TR As RainfallType)

If TH.hydrosteps = 0 Then
        MsgBox ("You must generate or retrieve a hydrograph before plotting")
        Exit Sub
End If
Graph1.GraphType = 6
Graph1.GraphStyle = 4
Graph1.GraphTitle = "Watershed Hydrograph"
Graph1.NumPoints = TH.hydrosteps
Graph1.AutoInc = 0
Graph1.BottomTitle = "Time (hours)"
Graph1.LeftTitle = "Flow (cfs)"
Graph1.NumSets = 1
Graph1.PatternedLines = 0
Graph1.ThisSet = 1
For i% = 1 To TH.hydrosteps
   Graph1.ThisPoint = i%
   Graph1.GraphData = TH.outflow(i%)
   Graph1.XPosData = i% * TH.timestep / 60
Next i%


End Sub

Sub PlotHyetograph (xmax As Single, TH As HydrographType, TR As RainfallType)
Dim i       As Integer
Dim x1      As Single
Dim x2      As Single
Dim y1      As Single
Dim y2      As Single
Dim Excess  As Single
x1 = 0
For i = 13 To 104 Step 13
   'COLOR 1, 7: 'Line (87, i)-(93, i)
   'COLOR 2, 7: 'Line (93, i)-(600, i)
Next i
'COLOR 1, 7

For i = 1 To TR.numbersteps - 1
        y1 = (TR.rain(i) * 50)
        If y1 < 1 Then y1 = 1
        y2 = 50 * ((TH.timestep * 60 * TH.runoff(i) * 12) / (TH.TotalArea * 43560))
        If y2 < 1 Then y2 = 1
        x1 = 90 + ((i - 1) * TR.timestep) / xmax * 550
        x2 = 90 + (i * TR.timestep) / xmax * 550

        'COLOR 6, 7        ' *****  Make Box around Excess ***
        'Line (x1, 1)-(x2, 1)    ' Axis
        'Line (x1, y2)-(x2, y2)  ' Top
        'Line (x1, 1)-(x1, y2)   ' Left Side
        'Line (x2, y2)-(x2, 1)   ' Right Side
'        IF x1 + 1 < x2 AND y2 > 2 THEN PAINT (x1 + 1, 2), CHR$(1), 6

        'COLOR 1, 7        '*****  Make Box around Rain *****

        'If y1 > y2 Then Line (x1, y2 + 1)-(x2, y2 + 1) ' Bottom
        'Line (x1, y1)-(x2, y1)  'Top
        'Line (x1, y2)-(x1, y1)  'Left
        'Line (x2, y1)-(x2, y2)  'Right
        'IF (y1 > (y2 + 2)) AND x2 > x1 + 1 THEN PAINT (x1 + 1, y2 + 2), CHR$(128), 1
Next i
'COLOR 1, 7
'Line (90, 1)-(x2, 1)

'locate 4, 6: 'print "1 in"
'locate 8, 6: 'print "2 in"
'locate 1, 1: COLOR 6, 7: 'print "Excess"
'locate 2, 1: COLOR 1, 7: 'print "Rainfall"
End Sub

Sub PlotPondRouting (TP As PondType)
If TP.numbersteps = 0 Then
        MsgBox ("You must route to a pond before plotting")
        Exit Sub
End If
Graph1.GraphType = 6
Graph1.GraphStyle = 4
Graph1.GraphTitle = "Pond Routing"
Graph1.NumPoints = TP.numbersteps
Graph1.AutoInc = 0
Graph1.BottomTitle = "Time (hours)"
Graph1.LeftTitle = "Flow (cfs)"
Graph1.NumSets = 2
Graph1.PatternedLines = 1
Graph1.ThisSet = 1
Graph1.PatternData = 1
Graph1.LegendText = "Pond Flow In"
For i% = 1 To TP.numbersteps
   Graph1.ThisPoint = i%
   Graph1.GraphData = TP.Inflow(i%)
   Graph1.XPosData = i% * TP.timestep / 60
Next i%
Graph1.ThisSet = 2
Graph1.ThisPoint = 2
Graph1.PatternData = 2

Graph1.LegendText = "Pond Flow Out"
For i% = 1 To TP.numbersteps
   Graph1.ThisPoint = i%
   Graph1.GraphData = TP.outflow(i%)
Next i%


End Sub

Sub PlotRainfall (TR As RainfallType)
If TR.numbersteps = 0 Then
        MsgBox ("You must generate or retrieve a rainfall before plotting")
        Exit Sub
End If

Graph1.GraphType = 6 'Line
Graph1.GraphStyle = 2
Graph1.GraphTitle = "Rainfall"
Graph1.NumPoints = TR.numbersteps
Graph1.AutoInc = 0
Graph1.BottomTitle = "Time (hours)"
Graph1.LeftTitle = "Rainfall (inches)"
Graph1.NumSets = 1
Graph1.PatternedLines = 0
Graph1.ThisSet = 1
For i% = 1 To TR.numbersteps
   Graph1.ThisPoint = i%
   Graph1.GraphData = TR.rain(i%)
   Graph1.XPosData = i% * TR.timestep / 60
Next i%


End Sub

Sub PlotSeries (Steps As Integer, StepsMax As Integer, Valy() As Single, ymax As Single, timestep As Single)
Dim j       As Integer
Dim i       As Integer
Dim xmax    As Single
Dim x1      As Single
Dim x2      As Single
Dim y1      As Single
Dim y2      As Single

ReDim valx(1 To Steps + 1)  As Single

xmax = CSng(StepsMax * timestep)
For j = 1 To Steps
        valx(j) = CSng(j * timestep)
        If valx(j) > xmax Then xmax = valx(j)
        'IF Valy(j) > ymax THEN ymax = Valy(j)
Next j

' Draw Hydrograph Plot

For i = 1 To Steps
   x1 = 90 + valx(i) / xmax * 550
   y1 = 280 - Valy(i) / ymax * 120
   x2 = 90 + valx(i + 1) / xmax * 550
   y2 = 280 - Valy(i + 1) / ymax * 120

   'If x2 >= x1 Then Line (x1, y1)-(x2, y2)
Next i
End Sub

