VERSION 2.00
Begin Form PlotForm 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Plot"
   ClientHeight    =   6600
   ClientLeft      =   120
   ClientTop       =   375
   ClientWidth     =   9315
   Height          =   7005
   Left            =   60
   LinkTopic       =   "Form1"
   ScaleHeight     =   6600
   ScaleWidth      =   9315
   Top             =   30
   Width           =   9435
   Begin CommandButton cmdPond 
      Caption         =   "P&ond"
      Height          =   495
      Left            =   7080
      TabIndex        =   8
      Top             =   5880
      Width           =   735
   End
   Begin CommandButton cmdRouting 
      Caption         =   "Ro&uting"
      Height          =   495
      Left            =   8040
      TabIndex        =   7
      Top             =   5880
      Width           =   975
   End
   Begin CommandButton cmdGrid 
      Caption         =   "&Grid"
      Height          =   495
      Left            =   3480
      TabIndex        =   6
      Top             =   5880
      Width           =   855
   End
   Begin CommandButton cmdHydrograph 
      Caption         =   "&Hydrograph"
      Height          =   495
      Left            =   5760
      TabIndex        =   5
      Top             =   5880
      Width           =   1095
   End
   Begin CommandButton cmdCopy 
      Caption         =   "&Copy"
      Height          =   495
      Left            =   2400
      TabIndex        =   4
      Top             =   5880
      Width           =   855
   End
   Begin CommandButton cmdPrint 
      Caption         =   "&Print"
      Height          =   495
      Left            =   1320
      TabIndex        =   3
      Top             =   5880
      Width           =   855
   End
   Begin CommandButton cmdPlotRainfall 
      Caption         =   "&Rainfall"
      Height          =   495
      Left            =   4560
      TabIndex        =   2
      Top             =   5880
      Width           =   975
   End
   Begin GRAPH Graph1 
      GraphType       =   0  'None
      Height          =   5535
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   9015
   End
   Begin CommandButton cmdDone 
      Cancel          =   -1  'True
      Caption         =   "&Done"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   5880
      Width           =   975
   End
End
Dim Node2Plot   As Integer

Sub cmdCopy_Click ()
   Graph1.DrawMode = 4
   Form_Load
End Sub

Sub cmdDone_Click ()
   Unload PlotForm
End Sub

Sub cmdGrid_Click ()
   i% = Graph1.GridStyle
   If i% = 3 Then i% = 0 Else i% = i% + 1
   Graph1.GridStyle = i%
   Graph1.DrawMode = 2
End Sub

Sub cmdHydrograph_Click ()
   If H.Hydrosteps = 0 Then Exit Sub
   Graph1.DataReset = 9
   PlotOption = 1: Form_Load
   Graph1.DrawMode = 2
End Sub

Sub cmdPlotRainfall_Click ()
   Graph1.DataReset = 9
   PlotOption = 2: Form_Load
   Graph1.DrawMode = 2
End Sub

Sub cmdPond_Click ()
   If P.NumberSteps = 0 Then Exit Sub
   Graph1.DataReset = 9
   PlotOption = 3: Form_Load
   Graph1.DrawMode = 2
End Sub

Sub cmdPrint_Click ()
   Graph1.DrawMode = 5
   Form_Load
End Sub

Sub cmdRouting_Click ()
   If Node2Plot < 12 Then Node2Plot = Node2Plot + 1 Else Node2Plot = 1
   While N(Node2Plot).Steps = 0
      If Node2Plot < 12 Then Node2Plot = Node2Plot + 1 Else Node2Plot = 1
   Wend
   Graph1.DataReset = 9
   PlotOption = 4: Form_Load
   Graph1.DrawMode = 2
End Sub

Sub Form_Load ()
If PlotOption = 1 Then PlotHydrograph H, R
If PlotOption = 2 Then PlotRainfall R
If PlotOption = 3 Then PlotPondRouting P
If PlotOption = 4 Then PlotNodeRouting
End Sub

Sub PlotHydrograph (TH As HydrographType, TR As RainfallType)

If TH.Hydrosteps = 0 Then
        MsgBox ("You must generate or retrieve a hydrograph before plotting")
        Exit Sub
End If
Graph1.GraphType = 6
Graph1.GraphStyle = 4
Graph1.GraphTitle = "Watershed Hydrograph"
Graph1.NumPoints = TH.Hydrosteps
Graph1.AutoInc = 0
Graph1.BottomTitle = "Time (hours)"
Graph1.LeftTitle = "Flow (cfs)"
Graph1.NumSets = 1
Graph1.PatternedLines = 0
Graph1.ThisSet = 1
For i% = 1 To TH.Hydrosteps
   Graph1.ThisPoint = i%
   Graph1.GraphData = TH.Outflow(i%)
   Graph1.XPosData = i% * TH.TimeStep / 60
Next i%


End Sub

Sub PlotHyetograph (xmax As Single, TH As HydrographType, TR As RainfallType)
Dim i       As Integer
Dim x1      As Single
Dim x2      As Single
Dim y1      As Single
Dim y2      As Single
Dim Excess  As Single
x1 = 0
For i = 13 To 104 Step 13
   'COLOR 1, 7: 'Line (87, i)-(93, i)
   'COLOR 2, 7: 'Line (93, i)-(600, i)
Next i
'COLOR 1, 7

For i = 1 To TR.NumberSteps - 1
        y1 = (TR.Rain(i) * 50)
        If y1 < 1 Then y1 = 1
        y2 = 50 * ((TH.TimeStep * 60 * TH.Runoff(i) * 12) / (TH.TotalArea * 43560))
        If y2 < 1 Then y2 = 1
        x1 = 90 + ((i - 1) * TR.TimeStep) / xmax * 550
        x2 = 90 + (i * TR.TimeStep) / xmax * 550

        'COLOR 6, 7        ' *****  Make Box around Excess ***
        'Line (x1, 1)-(x2, 1)    ' Axis
        'Line (x1, y2)-(x2, y2)  ' Top
        'Line (x1, 1)-(x1, y2)   ' Left Side
        'Line (x2, y2)-(x2, 1)   ' Right Side
'        IF x1 + 1 < x2 AND y2 > 2 THEN PAINT (x1 + 1, 2), CHR$(1), 6

        'COLOR 1, 7        '*****  Make Box around Rain *****

        'If y1 > y2 Then Line (x1, y2 + 1)-(x2, y2 + 1) ' Bottom
        'Line (x1, y1)-(x2, y1)  'Top
        'Line (x1, y2)-(x1, y1)  'Left
        'Line (x2, y1)-(x2, y2)  'Right
        'IF (y1 > (y2 + 2)) AND x2 > x1 + 1 THEN PAINT (x1 + 1, y2 + 2), CHR$(128), 1
Next i
'COLOR 1, 7
'Line (90, 1)-(x2, 1)

'locate 4, 6: 'print "1 in"
'locate 8, 6: 'print "2 in"
'locate 1, 1: COLOR 6, 7: 'print "Excess"
'locate 2, 1: COLOR 1, 7: 'print "Rainfall"
End Sub

Sub PlotNodeRouting ()
Dim count   As Integer
count = 0
While N(Node2Plot).Steps = 0
   If Node2Plot < 12 Then Node2Plot = Node2Plot + 1 Else Node2Plot = 1
   count = count + 1
   If count = 13 Then Exit Sub
Wend


Graph1.GraphType = 6
Graph1.GraphStyle = 4
Graph1.GraphTitle = "Routed Node " + Str$(Node2Plot) + " " + N(Node2Plot).TypeName
Graph1.NumPoints = N(Node2Plot).Steps
Graph1.AutoInc = 0
Graph1.BottomTitle = "Time (hours)"
Graph1.LeftTitle = "Flow (cfs)"
Graph1.NumSets = 2
Graph1.PatternedLines = 1
Graph1.ThisSet = 1
Graph1.PatternData = 1
Graph1.LegendText = "Node Flow In"
For i% = 1 To N(Node2Plot).Steps
   Graph1.ThisPoint = i%
   Graph1.GraphData = N(Node2Plot).Inflow(i%)
   Graph1.XPosData = i% * N(Node2Plot).TimeStep / 60
Next i%

Graph1.ThisSet = 2
Graph1.ThisPoint = 2
Graph1.PatternData = 2
Graph1.LegendText = "Node Flow Out"
For i% = 1 To N(Node2Plot).Steps
   Graph1.ThisPoint = i%
   Graph1.GraphData = N(Node2Plot).Outflow(i%)

Next i%

End Sub

Sub PlotPondRouting (TP As PondType)
If TP.NumberSteps = 0 Then
        MsgBox ("You must route to a pond before plotting")
        Exit Sub
End If
Graph1.GraphType = 6
Graph1.GraphStyle = 4
Graph1.GraphTitle = "Pond Routing"
Graph1.NumPoints = TP.NumberSteps
Graph1.AutoInc = 0
Graph1.BottomTitle = "Time (hours)"
Graph1.LeftTitle = "Flow (cfs)"
Graph1.NumSets = 2
Graph1.PatternedLines = 1
Graph1.ThisSet = 1
Graph1.PatternData = 1
Graph1.LegendText = "Pond Flow In"
For i% = 1 To TP.NumberSteps
   Graph1.ThisPoint = i%
   Graph1.GraphData = TP.Inflow(i%)
   Graph1.XPosData = i% * TP.TimeStep / 60
Next i%
Graph1.ThisSet = 2
Graph1.ThisPoint = 2
Graph1.PatternData = 2

Graph1.LegendText = "Pond Flow Out"
For i% = 1 To TP.NumberSteps
   Graph1.ThisPoint = i%
   Graph1.GraphData = TP.Outflow(i%)
Next i%


End Sub

Sub PlotRainfall (TR As RainfallType)
If TR.NumberSteps = 0 Then
        MsgBox ("You must generate or retrieve a rainfall before plotting")
        Exit Sub
End If

Graph1.GraphType = 6 'Line
Graph1.GraphStyle = 2
Graph1.GraphTitle = "Rainfall"
Graph1.NumPoints = TR.NumberSteps
Graph1.AutoInc = 0
Graph1.BottomTitle = "Time (hours)"
Graph1.LeftTitle = "Rainfall (inches)"
Graph1.NumSets = 1
Graph1.PatternedLines = 0
Graph1.ThisSet = 1
For i% = 1 To TR.NumberSteps
   Graph1.ThisPoint = i%
   Graph1.GraphData = TR.Rain(i%)
   Graph1.XPosData = i% * TR.TimeStep / 60
Next i%


End Sub

Sub PlotSeries (Steps As Integer, StepsMax As Integer, Valy() As Single, ymax As Single, TimeStep As Single)
Dim j       As Integer
Dim i       As Integer
Dim xmax    As Single
Dim x1      As Single
Dim x2      As Single
Dim y1      As Single
Dim y2      As Single

ReDim valx(1 To Steps + 1)  As Single

xmax = CSng(StepsMax * TimeStep)
For j = 1 To Steps
        valx(j) = CSng(j * TimeStep)
        If valx(j) > xmax Then xmax = valx(j)
        'IF Valy(j) > ymax THEN ymax = Valy(j)
Next j

' Draw Hydrograph Plot

For i = 1 To Steps
   x1 = 90 + valx(i) / xmax * 550
   y1 = 280 - Valy(i) / ymax * 120
   x2 = 90 + valx(i + 1) / xmax * 550
   y2 = 280 - Valy(i + 1) / ymax * 120

   'If x2 >= x1 Then Line (x1, y1)-(x2, y2)
Next i
End Sub

