DECLARE SUB Output15MEventToSingle (RainDate AS STRING, RainYear AS INTEGER, steps AS INTEGER, Rainfall() AS SINGLE)
DECLARE FUNCTION EventSize! (n AS INTEGER)
DECLARE FUNCTION EventNumber% (Size AS SINGLE)
DECLARE FUNCTION NewEvent% (EventSteps AS INTEGER, Rainfall() AS SINGLE)
DECLARE SUB OutputAllEvents (EventDate AS STRING, RainYear AS INTEGER, EventSteps AS INTEGER, REvent() AS SINGLE)
DECLARE FUNCTION JustMonth% (InitialYear AS STRING)
DECLARE FUNCTION JustDay% (InitialYear AS STRING)
DECLARE FUNCTION HourlyIn15MData% (steps AS INTEGER, Rainfall() AS SINGLE)
DECLARE SUB ResetYearParse ()
DECLARE SUB OpenFiles ()
DECLARE SUB CloseFiles ()
DECLARE FUNCTION JustPath$ (InitialFile AS STRING)
'$FORM Status
'$INCLUDE: 'rp15.bi'
'$INCLUDE: 'cmndlg.bi'

SUB CloseFiles ()
CLOSE #1
IF OutputFileType = SEP_FILE THEN
   IF DoFlag(1) = TRUE THEN CLOSE #2
   IF DoFlag(2) = TRUE THEN CLOSE #3
   IF DoFlag(3) = TRUE THEN CLOSE #4
   IF DoFlag(4) = TRUE THEN CLOSE #5
   IF DoFlag(5) = TRUE THEN CLOSE #6
   IF DoFlag(6) = TRUE THEN CLOSE #7
   IF DoFlag(7) = TRUE THEN CLOSE #8
   IF DoFlag(8) = TRUE THEN CLOSE #9
   IF DoFlag(9) = TRUE THEN CLOSE #10
   IF DoFlag(10) = TRUE THEN CLOSE #11
   IF DoFlag(11) = TRUE THEN CLOSE #12
   IF DoFlag(12) = TRUE THEN CLOSE #13
ELSEIF OutputFileType = ONE_FILE THEN
    CLOSE #16
END IF

IF DoEventFlag = TRUE THEN CLOSE #14
END SUB

FUNCTION EventNumber% (Size AS SINGLE)
SELECT CASE Size
   CASE .25: EventNumber% = 1
   CASE .5: EventNumber% = 2
   CASE 1: EventNumber% = 3
   CASE 2: EventNumber% = 4
   CASE 4: EventNumber% = 5
   CASE 6: EventNumber% = 6
   CASE 10: EventNumber% = 7
   CASE 12: EventNumber% = 8
   CASE 24: EventNumber% = 9
   CASE 36: EventNumber% = 10
   CASE 48: EventNumber% = 11
   CASE 72: EventNumber% = 12
END SELECT
END FUNCTION

FUNCTION EventSize! (n AS INTEGER)
SELECT CASE n
   CASE 1: EventSize! = .25
   CASE 2: EventSize! = .5
   CASE 3: EventSize! = 1
   CASE 4: EventSize! = 2
   CASE 5: EventSize! = 4
   CASE 6: EventSize! = 6
   CASE 7: EventSize! = 10
   CASE 8: EventSize! = 12
   CASE 9: EventSize! = 24
   CASE 10: EventSize! = 36
   CASE 11: EventSize! = 48
   CASE 12: EventSize! = 72
END SELECT

END FUNCTION

FUNCTION HourlyIn15MData% (steps AS INTEGER, Rainfall() AS SINGLE)

FOR i% = 1 TO steps - 3
   IF Rainfall(i%) <> 0 THEN
      FOR j% = 1 TO 3
          IF Rainfall(i% + j%) <> 0 THEN
             HourlyIn15MData% = FALSE
             EXIT FUNCTION
          END IF
      NEXT j%
   END IF
NEXT i%
HourlyIn15MData% = TRUE
END FUNCTION

FUNCTION JustDay% (InitialYear AS STRING)
DIM p AS INTEGER
   dummy$ = InitialYear
   p = INSTR(dummy$, "/")
   dummy$ = RIGHT$(dummy$, LEN(dummy$) - p)
   p = INSTR(dummy$, "/")
   dummy$ = LEFT$(dummy$, p)
   JustDay% = VAL(dummy$)
END FUNCTION

FUNCTION JustFile$ (InitialFile AS STRING)
DIM p AS INTEGER
   p = -1
   dummy$ = InitialFile
   DO
       p = INSTR(dummy$, "\")
       dummy$ = RIGHT$(dummy$, LEN(dummy$) - p)
   LOOP WHILE p <> 0
   JustFile$ = dummy$
END FUNCTION

FUNCTION JustMonth% (InitialYear AS STRING)
DIM p AS INTEGER
   
   dummy$ = InitialYear
   p = INSTR(dummy$, "/")
   dummy$ = LEFT$(dummy$, p)
   JustMonth% = VAL(dummy$)

END FUNCTION

FUNCTION JustPath$ (InitialFile AS STRING)
DIM p   AS INTEGER
DIM lp  AS INTEGER

   p = -1
   lp = 0
   Dummy1$ = InitialFile
   Dummy2$ = InitialFile

   DO
       p = INSTR(Dummy1$, "\")
       IF p > 0 THEN lp = lp + p
       
       Dummy1$ = RIGHT$(Dummy1$, LEN(Dummy1$) - p)
   LOOP WHILE p <> 0
   Dummy2$ = LEFT$(Dummy2$, lp - 1)
   JustPath$ = Dummy2$

END FUNCTION

FUNCTION JustYear% (InitialYear AS STRING)
DIM p AS INTEGER
   p = -1
   dummy$ = InitialYear
   DO
       p = INSTR(dummy$, "/")
       dummy$ = RIGHT$(dummy$, LEN(dummy$) - p)
   LOOP WHILE p <> 0
   JustYear% = VAL(dummy$)
END FUNCTION

FUNCTION MaximumVolume! (Duration AS SINGLE, steps AS INTEGER, Rainfall() AS SINGLE)
DIM i           AS INTEGER
DIM j           AS INTEGER
DIM Dsteps      AS INTEGER
DIM passes      AS INTEGER

DIM Total       AS SINGLE
DIM MaxTotal    AS SINGLE

Dsteps = INT((Duration + .01) * 4)
IF Dsteps >= steps THEN
   Dsteps = steps
   passes = 1
ELSE
   passes = steps - Dsteps
END IF

MaxTotal = 0

' ***** Check for Hourly Data and exit if data is hourly ************
' ***** for all storms less than 1 hour *****************************

IF Duration < .7 THEN
      IF HourlyIn15MData%(steps, Rainfall()) = TRUE THEN
         MaximumVolume! = 0
         EXIT FUNCTION
      END IF
END IF

' ****** For 15 Minute storms find the maximum value ****************
' ****** and exit. **************************************************

IF Duration <= .26 THEN
   FOR i = 1 TO steps
      IF Rainfall(i) > MaxTotal THEN MaxTotal = Rainfall(i)
   NEXT i
MaximumVolume! = MaxTotal
EXIT FUNCTION
END IF

FOR i = 1 TO passes
    Total = 0!
    FOR j = i TO i + Dsteps
        Total = Total + Rainfall(j)
    NEXT j
    IF Total > MaxTotal THEN MaxTotal = Total
NEXT i
MaximumVolume! = MaxTotal
END FUNCTION

FUNCTION NewEvent% (EventSteps AS INTEGER, Rainfall() AS SINGLE)
SepSteps% = EventSeparation / 15
IF SepSteps% < 1 THEN SepSteps% = 1

NewEvent% = TRUE
IF EventSteps > SepSteps% THEN     ' ** Inside Rainfall Event **
   TotalRain! = 0
   FOR i% = EventSteps TO EventSteps - SepSteps% STEP -1
       TotalRain! = TotalRain! + Rainfall(i%)
   NEXT i%
   IF TotalRain! <> 0 THEN NewEvent% = FALSE
ELSE
   TotalRain! = 0
   FOR i% = 1 TO EventSteps
       TotalRain! = TotalRain! + Rainfall(i%)
   NEXT i%
   IF TotalRain! <> 0 THEN NewEvent% = FALSE
END IF


END FUNCTION

SUB OpenFiles ()
DIM i       AS INTEGER
DIM f       AS INTEGER
OPEN InputFile$ FOR INPUT AS #1
IF OutputFileType = SEP_FILE THEN
   FOR i = 1 TO 12
      f = i + 1
      IF DoFlag(i) = TRUE THEN OPEN SOutputFile(1) FOR OUTPUT AS #f
   NEXT i
ELSEIF OutputFileType = ONE_FILE THEN
   OPEN OutputFile$ FOR OUTPUT AS #16
END IF

IF DoEventFlag = TRUE THEN OPEN EventFile$ FOR OUTPUT AS #14


END SUB

SUB Output15MEventToSingle (RainDate AS STRING, RainYear AS INTEGER, steps AS INTEGER, Rainfall() AS SINGLE)

STATIC CurrentYear  AS INTEGER
DIM i               AS INTEGER
DIM n               AS INTEGER
DIM f               AS INTEGER

DIM Size            AS SINGLE
DIM Maximum         AS SINGLE
DIM Total           AS SINGLE
DIM EventDuration   AS SINGLE

' ***********************************************************************
'   Size - output interval in hours
'   steps - Number of Steps in Event
'   RainYear - Year of Rainfall
' ***********************************************************************

EventDuration = steps * 15

FOR i = 1 TO 12
   Size = EventSize!(i)
   Total = MaximumVolume!(Size, steps, Rainfall())
   IF Total > EventMax(i) THEN
      EventMax(i) = Total
      EventDate(i) = RainDate
   END IF
   IF EventMax(i) > YearMax(i) THEN YearMax(i) = EventMax(i)
NEXT i

IF RainYear <> CurrentYear THEN
       FOR i = 1 TO 12
            CurrentYear = RainYear
            IF DoFlag(i) = TRUE THEN PRINT #16, EventDate(i); ","; YearMax(i); ",";
            EventMax(i) = 0
            YearMax(i) = 0
       NEXT i
       PRINT #16,
END IF
END SUB

SUB OutputAllEvents (EventDate AS STRING, RainYear AS INTEGER, EventSteps AS INTEGER, REvent() AS SINGLE)
IF OutputFileType = SEP_FILE THEN
   IF DoFlag(1) = TRUE THEN ParseLarge15MEvent .25, EventDate, RainYear, EventSteps, REvent()
   IF DoFlag(2) = TRUE THEN ParseLarge15MEvent .5, EventDate, RainYear, EventSteps, REvent()
   IF DoFlag(3) = TRUE THEN ParseLarge15MEvent 1, EventDate, RainYear, EventSteps, REvent()
   IF DoFlag(4) = TRUE THEN ParseLarge15MEvent 2, EventDate, RainYear, EventSteps, REvent()
   IF DoFlag(5) = TRUE THEN ParseLarge15MEvent 4, EventDate, RainYear, EventSteps, REvent()
   IF DoFlag(6) = TRUE THEN ParseLarge15MEvent 6, EventDate, RainYear, EventSteps, REvent()
   IF DoFlag(7) = TRUE THEN ParseLarge15MEvent 10, EventDate, RainYear, EventSteps, REvent()
   IF DoFlag(8) = TRUE THEN ParseLarge15MEvent 12, EventDate, RainYear, EventSteps, REvent()
   IF DoFlag(9) = TRUE THEN ParseLarge15MEvent 24, EventDate, RainYear, EventSteps, REvent()
   IF DoFlag(10) = TRUE THEN ParseLarge15MEvent 36, EventDate, RainYear, EventSteps, REvent()
   IF DoFlag(11) = TRUE THEN ParseLarge15MEvent 48, EventDate, RainYear, EventSteps, REvent()
   IF DoFlag(12) = TRUE THEN ParseLarge15MEvent 72, EventDate, RainYear, EventSteps, REvent()
ELSEIF OutputFileType = ONE_FILE THEN
   Output15MEventToSingle EventDate, RainYear, EventSteps, REvent()
END IF

END SUB

SUB OutputParsedEvent (RainDate AS STRING, steps AS INTEGER, Rainfall() AS SINGLE)
PRINT #14, RainDate; ","; steps;
FOR i% = 1 TO steps
    IF INT(i% / 50) = (CSNG(i%) / 50!) THEN
        PRINT #14,
        PRINT #14, "       "; RTRIM$(LTRIM$(STR$(Rainfall(i%))));
    ELSE
        PRINT #14, ","; RTRIM$(LTRIM$(STR$(Rainfall(i%))));
    END IF
NEXT i%
PRINT #14,

END SUB

FUNCTION OutputsSet% ()
DIM i   AS INTEGER
Flag% = FALSE
FOR i = 1 TO 12
   IF DoFlag(i) = TRUE THEN Flag% = TRUE
NEXT i
IF DoEventFlag = TRUE THEN Flag% = TRUE
OutputsSet% = Flag%
END FUNCTION

SUB Parse15MinuteDataToEvent ()
DIM Rainfall(240)       AS SINGLE
DIM REvent(NUMSTEPS)    AS SINGLE
DIM RainYear            AS INTEGER
DIM i                   AS INTEGER

DIM SerialDate          AS SINGLE
DIM LastSerialDate      AS SINGLE
DIM EventSerial         AS SINGLE

InEventFlag% = FALSE
EventSteps% = 0

IF OutputsSet() = FALSE THEN
   MSGBOX ("There are no outputs specified")
   EXIT SUB
END IF

'ON LOCAL ERROR GOTO Parse15MtoEventError
CloseFiles
ExitFlag% = TRUE
OpenFiles
record% = 0
EventNum% = 0
Status.SHOW 0


WHILE NOT EOF(1)

'   ******************   Display Parsing Status ************************

      IF ParseMethod = BY_EVENT THEN
         Status.Text1.Text = "Parsing Record " + STR$(record%) + " Event " + STR$(EventNum%)
      END IF

      IF ParseMethod = BY_YEAR THEN
         Status.Text1.Text = "Parsing Record " + STR$(record%) + " Date " + RainDate$ + " Event " + STR$(EventNum%)
      END IF

'   *************************************************************************

      record% = record% + 1         ' Increment record number

'   *******      Read in Data from File     *********************************

      INPUT #1, State$, StateCode%, SiteCode%, RainUnit$, RainDate$
      IF State$ = "FL" THEN GOSUB OpenNewDay   ' Get Data From Disk

'   **********  Set Year and date for checking of data consistency **********

      EventDate$ = RainDate$
      RainYear = JustYear%(RainDate$)
      LastSerialDate = SerialDate
      SerialDate = DATESERIAL(RainYear, JustMonth(RainDate$), JustDay%(RainDate$))

'   *****************  Set all the Years on successive outputs *************


'   ******* Parse New Day Into Current Event *******************************

'   ******* If Date is not Consecutive automatically a new event ***********
      
      IF record% = 1 THEN
         EventNum% = 1
      ELSE
         IF SerialDate <> (LastSerialDate + 1) THEN GOSUB OutputEvent
      END IF

'   ******* Go through the data and form event *****************************
'   ******* and either add rainfall to event or ****************************
'   ******* start new event ************************************************

      FOR j% = 1 TO 96
         IF EventSteps% = NUMSTEPS THEN GOSUB OutputEvent
         IF InEventFlag% THEN
            IF Rainfall(j%) <> 0 THEN
               EventSteps% = EventSteps% + 1
               REvent(EventSteps%) = Rainfall(j%)
            ELSE
               IF NewEvent%(EventSteps%, REvent()) THEN
                  GOSUB OutputEvent
               ELSE
                  EventSteps% = EventSteps% + 1
                  REvent(EventSteps%) = Rainfall(j%)
               END IF
            END IF
         ELSE                          ' **** Not currently in an event *****
            IF Rainfall(j%) <> 0 THEN  ' **** Start New Event ***************
               InEventFlag% = TRUE
               EventSteps% = 1

               REvent(1) = Rainfall(j%)
            END IF
         END IF
     NEXT j%
WEND

' *************  Output Last Of Events ************************************

IF ParseMethod = BY_YEAR THEN
   RainYear = RainYear + 1
   GOSUB OutputEvent
END IF

CloseFiles

UNLOAD Status
EXIT SUB

' ***************   Output Subroutine          ****************************

OutputEvent:
   GOSUB Shave
   OutputAllEvents EventDate$, RainYear, EventSteps%, REvent()
   IF DoEventFlag = TRUE THEN OutputParsedEvent EventDate$, EventSteps%, REvent()
   InEventFlag% = FALSE
   EventSteps% = 1
   EventNum% = EventNum% + 1
RETURN

' ***************   Input Subroutine for Input ****************************

OpenNewDay:
      GoodDayFlag% = TRUE
      DayTotal! = 0
      FOR i% = 1 TO 96
        INPUT #1, TI$
        IF TI$ = "A" OR TI$ = "M" OR TI$ = "D" THEN
           Rainfall(i%) = 0
        ELSEIF TI$ = "---" THEN     'Throw out the rest of the day
           Rainfall(i%) = 0
           GoodDayFlag% = FALSE
        ELSE
           IF GoodDayFlag% = TRUE THEN
              Rainfall(i%) = VAL(TI$)
              DayTotal! = DayTotal! + Rainfall(i%)
           END IF
        END IF

        INPUT #1, dummy!
      NEXT i%
      INPUT #1, DayRain!
      INPUT #1, dummy!

      IF DayTotal! <> DayRain! THEN     ' Throw out day if totals don't match
         FOR i% = 1 TO 96
            Rainfall(i%) = 0
         NEXT i%
      END IF
RETURN

StartEvent:
RETURN
EXIT SUB

'   ************        Shave all zeroes off end of Event ****************

Shave:
   tempsteps% = EventSteps%
   FOR i% = tempsteps% TO 1 STEP -1
      IF REvent(i%) <> 0 THEN
         EventSteps% = i%
         RETURN
      END IF
   NEXT i%
RETURN

Parse15MtoEventError:
   IF ERR = 64 THEN
       MSGBOX ("You Must Specify an Input File")
       CloseFiles

       EXIT SUB
   END IF
   MSGBOX ("Error " + STR$(ERR) + " occurred: " + ERROR$)
   CloseFiles

   EXIT SUB
RESUME
END SUB

SUB ParseLarge15MEvent (Size AS SINGLE, RainDate AS STRING, RainYear AS INTEGER, steps AS INTEGER, Rainfall() AS SINGLE)

DIM n               AS INTEGER
DIM f               AS INTEGER

DIM Maximum         AS SINGLE
DIM Total           AS SINGLE
DIM EventDuration   AS SINGLE

' ***********************************************************************
'   Size - output interval in hours
'   steps - Number of Steps in Event
'   RainYear - Year of Rainfall
' ***********************************************************************

EventDuration = steps * 15
EventMax = 0

'   *************** Determine Integer Code of Event Being Output *********

n = EventNumber%(Size)
f = n + 1

'   ************* Determines Maximum Rainfall of Given Duration in Event

Total = MaximumVolume!(Size, steps, Rainfall())
IF Total > EventMax(n) THEN
   EventMax(n) = Total
   EventDate(n) = RainDate
END IF

IF ParseMethod = BY_EVENT THEN
  IF EventMax(n) <> 0 THEN PRINT #f, EventMax(n)
  EXIT SUB
END IF

IF ParseMethod = BY_YEAR THEN
   IF EventMax(n) > YearMax(n) THEN YearMax(n) = EventMax(n)
   IF RainYear <> TempYear(n) THEN
         TempYear(n) = RainYear
         PRINT #f, EventDate(n); ","; YearMax(n)
         YearMax(n) = EventMax(n)
      END IF
END IF
END SUB

SUB ResetYearParse ()
FOR i% = 1 TO 12
 TempYear(i%) = 0
NEXT i%

END SUB

SUB RunScript (FileName AS STRING)
    OPEN FileName$ FOR INPUT AS #15
    WHILE NOT EOF(15)
       INPUT #15, InputFile$
       IF LEN(InputFile$) > 5 THEN
           PathName$ = JustPath$(InputFile$)
           CHDRIVE PathName$: CHDIR PathName$
           ResetYearParse
           IF ParseMethod = BY_EVENT THEN Parse15MinuteDataToEvent
           IF ParseMethod = BY_YEAR THEN Parse15MinuteDataToEvent
       END IF
   WEND
CLOSE #15
END SUB

