DECLARE FUNCTION GetDiameter! (Diameter!, activenode%)
DECLARE FUNCTION GetNode% (Message$, FlowToFlag%, ActiveFlag%, n AS ANY)
DECLARE FUNCTION GetTimeCon% (g%, n1!, s!, q!, z!, D!, l!, r AS ANY, n AS ANY)
DECLARE FUNCTION getVal! (n AS INTEGER, xo AS SINGLE, x() AS SINGLE, y() AS SINGLE)
DECLARE SUB PondRoute (activenode%, pond AS ANY, r AS ANY, n AS ANY)
DECLARE FUNCTION truncate$ (vari AS SINGLE, places AS INTEGER)

DEFINT A-Y
SUB DefineNode (p() AS pondtype, h AS hydrographtype, r AS rainfalltype, n AS nodetype)
DIM a$(MAXNODES)
DIM b$(5)

b$(1) = "Watershed Node"
b$(2) = "Pond Node"
b$(3) = "Junction Node"
b$(4) = "Final Outlet"
b$(5) = "Batch Data File"
nodetype = GetAnswer(5, b$(), "Choose Node Type")

IF nodetype = 0 THEN EXIT SUB

FOR i = 1 TO MAXNODES
        a$(i) = "Node " + STR$(i):
        IF n.NodeExist(i) = TRUE THEN a$(i) = a$(i) + "  " + n.NodeLabel(i)
NEXT i

NodeNumber = MultAnswer(MAXNODES, a$(), "Choose Number to assign to node")
IF n.NodeExist(NodeNumber) = TRUE THEN junk = Alert(4, "Node is already defined, redefine?", 5, 10, 8, 70, "Yes", "No", "")
IF junk = 2 THEN EXIT SUB
IF junk = 1 THEN FOR i = 1 TO MAXSTEPS: n.NodeInflow(NodeNumber, i) = 0: n.NodeOutflow(activenode, i) = 0: NEXT i

IF NodeNumber = 0 THEN EXIT SUB
activenode = NodeNumber

Message$ = "Enter a Name for Node # " + STR$(NodeNumber)
n.NodeLabel(NodeNumber) = GetLabel$(b$(nodetype), Message$)

IF nodetype = 5 THEN RetrieveBatchNode h, r, n

IF nodetype = 1 THEN
        RetrieveHydroFile h, r
        IF h.HydroSteps = 0 THEN EXIT SUB

        FOR i = 1 TO h.HydroSteps
                n.NodeInflow(NodeNumber, i) = h.Outflow(i)
        NEXT i
END IF

n.NodeExist(NodeNumber) = TRUE
n.nodetype(NodeNumber) = nodetype
IF nodetype = 2 THEN RetrieveStorDisRel p(activenode)
colordisplay

END SUB

FUNCTION GetDiameter! (Diameter!, activenode%)
REDIM a$(2)
a$ = "Required Diameter =" + STR$(Diameter!) + " in"
a$(1) = "Use Standard Diameter"
a$(2) = "Input Custom Diameter"
Diachoice = GetAnswer(2, a$(), a$)
IF Diachoice = 1 THEN
        WHILE Diameter! > standardPipe
                standardPipe = 9 + 3 * i
                IF i > 7 THEN standardPipe = 30 + (i - 7) * 6
                IF i > 12 THEN standardPipe = 60 + (i - 12) * 12
                i = i + 1
        WEND
        GetDiameter! = standardPipe
ELSE
        GetDiameter! = VAL(GetLabel$("", "Input Diameter in Inches"))
END IF
END FUNCTION

FUNCTION GetNode (Message$, FlowToFlag, ActiveFlag, n AS nodetype)
' FlowToFlag -  Enables checking for other nodes flowing to node and does not list
' ActiveFlag -  Does not list current Active Node

DIM a(MAXNODES)
REDIM a$(MAXNODES)

LastActiveNode = activenode

j = 1
FOR i = 1 TO MAXNODES
        IF FlowToFlag = TRUE AND n.FlowTo(i) = 0 THEN FlowFlag = TRUE
        IF FlowToFlag = FALSE THEN FlowFlag = TRUE
        IF i = activenode AND ActiveFlag = TRUE THEN ActFlag = FALSE ELSE ActFlag = TRUE
        IF n.NodeExist(i) = TRUE AND FlowFlag = TRUE AND ActFlag = TRUE THEN
                a$(j) = "Node " + STR$(i) + "  " + n.NodeLabel(i)
                a(j) = i
                j = j + 1
        END IF
NEXT i

j = j - 1
IF j = 0 THEN GetNode = 0: EXIT FUNCTION
DummyNode = MultAnswer(j, a$(), Message$)
DummyNode = a(DummyNode)
GetNode = DummyNode
colordisplay
END FUNCTION

FUNCTION GetTimeCon (g%, n1!, s!, q!, z!, D!, l!, r AS rainfalltype, n AS nodetype)
STATIC y!
ON LOCAL ERROR GOTO tchandler
IF n.NodeGeometry(activenode) = 2 THEN
        IF y! = 0 THEN y! = 2: incr! = .1
        fy! = 1
        WHILE ABS(fy!) > .001
                dum1! = ((D! + z! * y!) * y! / (D! + 2 * y! * (1 + z! ^ 2) ^ .5)) ^ .6667
                fy! = (D! * y! * (1.486 / n1!) * dum1! * s! ^ .5) - q!
                IF SGN(fy!) <> SGN(fy2!) THEN incr! = incr! / 2
                IF fy! > 0 THEN y! = y! - incr! ELSE y! = y! + incr!
                IF incr! = 0 THEN incr! = .1
                fy2! = fy!
        WEND
        v! = q! / ((D! + z! * y!) * y!)
        IF y! > n.Depth(activenode) THEN n.Depth(activenode) = y!
ELSE
        IF y! = 0 THEN y! = 1.55
        incr! = .1
        fy! = 1
        WHILE ABS(fy!) > .001
                fy! = (1 / 8) * (y! - SIN(y!)) * D! ^ 2 * (1.486 / n1!) * (.25 * (1 - SIN(y!) / y!) * D!) ^ .6667 * s! ^ .5 - n.NodeInflow(activenode, 1)
                IF SGN(fy!) <> SGN(fy2!) THEN incr! = incr! / 2
                IF fy! > 0 THEN y! = y! - incr! ELSE y! = y! + incr!
                IF incr! = 0 THEN incr! = .1
                fy2! = fy!
        WEND
        IF y! > .1 THEN v! = q! / ((y! - SIN(y!) / 8) * D! ^ 2)
END IF
IF v! > n.Velocity(activenode) THEN n.Velocity(activenode) = v!
IF v! > .01 THEN a = CINT(l! / (v! * 60))
IF v! = 0 THEN a = r.RainTimeStep
GetTimeCon = a
EXIT FUNCTION
tchandler:
        a$ = "Error !! Parameter Overflow|To Correct, Unlink Node and Relink using another method."
        junk = Alert(4, a$, 9, 10, 14, 70, "", "", "")
        GetTimeCon = -1
        EXIT FUNCTION
END FUNCTION

SUB LinkNode (p() AS pondtype, h AS hydrographtype, r AS rainfalltype, n AS nodetype)
DIM PeakNodeInflow      AS SINGLE
DIM c                   AS SINGLE
DIM Depth               AS SINGLE
DIM Manning             AS SINGLE
DIM Diameter            AS SINGLE
DIM Slope               AS SINGLE
DIM Bottom              AS SINGLE
DIM Length              AS SINGLE
DIM a(MAXNODES)
REDIM a$(MAXNODES)

ContinueFlag = FALSE
FOR i = 1 TO MAXNODES
        IF n.NodeExist(i) = TRUE THEN ContinueFlag = TRUE
NEXT i
IF ContinueFlag = FALSE THEN
        a1$ = "There are no nodes defined. To link nodes"
        a1$ = a1$ + "|first go to the Define nodes routine and"
        a1$ = a1$ + "|define all your nodes, after the nodes are"
        a1$ = a1$ + "|defined then use the link routine, don't"
        a1$ = a1$ + "|forget to define your final outlet."
        junk = Alert(4, a1$, 10, 10, 16, 70, "", "Continue", "")
        EXIT SUB
END IF

activenode = GetNode("Enter Source Node Number", TRUE, FALSE, n)
IF activenode = 0 THEN EXIT SUB

n.FlowTo(activenode) = GetNode("Enter Reception Node Number", TRUE, TRUE, n)
IF n.FlowTo(activenode) = 0 THEN EXIT SUB

a$(1) = "Circular"
a$(2) = "Trapezoidal"
a$(3) = "No Transport Structure"

IF n.nodetype(activenode) = 1 OR n.nodetype(activenode) = 3 OR n.nodetype(activenode) = 5 THEN
        n.NodeGeometry(activenode) = GetAnswer(3, a$(), "Choose Transport Geometry")
END IF

IF n.NodeGeometry(activenode) = 1 OR n.NodeGeometry(activenode) = 2 THEN
        n.Slope(activenode) = VAL(GetLabel$("", "Enter The Slope as a fraction"))
        Manning = VAL(GetLabel$(".013", "Enter Manning's Coefficient"))
        Length = VAL(GetLabel$("", "Enter the channel/pipe length in feet"))
        IF Length <= 0 THEN n.NodeGeometry(activenode) = 3
        IF n.NodeGeometry(activenode) = 2 THEN SideSlopes! = VAL(GetLabel$(".25", "Enter side slope vert/horiz"))
END IF

FOR j = 1 TO MAXSTEPS
        IF n.NodeInflow(activenode, j) > PeakNodeInflow THEN PeakNodeInflow = n.NodeInflow(activenode, j)
        IF n.NodeGeometry(activenode) = 3 THEN
                n.NodeOutflow(activenode, j) = n.NodeInflow(activenode, j)
                n.NodeInflow(n.FlowTo(activenode), j) = n.NodeOutflow(activenode, j) + n.NodeInflow(n.FlowTo(activenode), j)
        END IF
NEXT j

IF n.NodeGeometry(activenode) = 3 THEN colordisplay: EXIT SUB
IF n.nodetype(activenode) = 2 THEN PondRoute activenode, p(activenode), r, n: colordisplay: EXIT SUB

IF n.NodeGeometry(activenode) = 1 THEN
        Diameter = 12 * (PeakNodeInflow * Manning * 2.16 / n.Slope(activenode) ^ .5) ^ .375
        Diameter = GetDiameter(Diameter, activenode)
        
        D! = Diameter / 12
        junk = Alert(4, "Diameter Used = " + STR$(Diameter) + " in", 9, 10, 14, 70, "", "", "")
END IF

IF n.NodeGeometry(activenode) = 2 THEN
        z! = 1 / SideSlopes!
        c! = 2 * ((SQR(1 + z! ^ 2)) - (z!))
        Depth = (PeakNodeInflow * Manning * 1.07 / ((c! + z!) * n.Slope(activenode) ^ .5)) ^ .375
        Bottom = c! * Depth
        D! = Bottom
        IF D! = 0 THEN D! = 1
        NodeTimeCon = GetTimeCon(2, Manning, n.Slope(activenode), n.NodeInflow(activenode, 1), z!, D!, Length, r, n)
        IF NodeTimeCon = -1 THEN EXIT SUB
END IF

i = 1
n.NodeOutflow(activenode, 0) = 0

WHILE Steps < MAXSTEPS
        IF n.NodeInflow(activenode, i) > .001 THEN
                NodeTimeCon = GetTimeCon(n.NodeGeometry(activenode), Manning, n.Slope(activenode), n.NodeInflow(activenode, i), z!, D!, Length, r, n)
                IF NodeTimeCon = -1 THEN EXIT SUB
        ELSE
                NodeTimeCon = 0
        END IF
        h.KR = CSNG(r.RainTimeStep / (2 * NodeTimeCon + r.RainTimeStep))
        n.NodeOutflow(activenode, i) = n.NodeOutflow(activenode, i - 1) + h.KR * (n.NodeInflow(activenode, i - 1) + n.NodeInflow(activenode, i) - 2 * n.NodeOutflow(activenode, i - 1))
        IF n.NodeOutflow(activenode, i) > n.PeakNodeOutflow THEN n.PeakNodeOutflow = n.NodeOutflow(activenode, i): p(activenode).peakstep = i
        IF Offset = 0 THEN Offset = NodeTimeCon / r.RainTimeStep
        i = i + 1
        Steps = i
        LOCATE 5, 15
        PRINT 2, "Routing in Progress Step:" + STR$(i) + "   "
WEND

IF Offset > 0 THEN Offset = Offset - 1
IF Steps + Offset > MAXSTEPS - 2 THEN Steps = MAXSTEPS - 2 - Offset

FOR i = Offset + Steps TO Offset STEP -1
        n.NodeOutflow(activenode, i) = n.NodeOutflow(activenode, i - Offset)
        IF n.NodeInflow(activenode, i) < .0001 * n.PeakNodeOutflow THEN n.NodeInflow(activenode, i) = 0
        IF n.NodeOutflow(activenode, i) < .0001 * n.PeakNodeOutflow THEN n.NodeOutflow(activenode, i) = 0
NEXT i

FOR i = 1 TO Offset
        n.NodeOutflow(activenode, i) = 0
NEXT i

FOR j = 1 TO MAXSTEPS
        IF n.NodeOutflow(activenode, j - 1) < .01 AND n.NodeOutflow(activenode, j) > .01 AND j > p(activenode).peakstep THEN n.NodeOutflow(activenode, j) = 0
        n.NodeInflow(n.FlowTo(activenode), j) = n.NodeOutflow(activenode, j) + n.NodeInflow(n.FlowTo(activenode), j)
NEXT j


n.Length(activenode) = Length
n.Diameter(activenode) = D!
n.Bas(activenode) = Bottom
IF z! <> 0 THEN n.SideSlope(activenode) = 1 / z!

colordisplay
END SUB

DEFSNG A-Y
SUB ShedCalc (w AS watershedtype)

IF w.DCIA <> 0 THEN w.FracDCIA = (w.ImpArea / w.TotalArea) * (w.DCIA / 100)
IF w.TotalArea <> 0 THEN
        w.FracDCIA = (w.DCIA / 100) * w.ImpArea / w.TotalArea
        w.FracNDCIA = (w.ImpArea / w.TotalArea) * ((100 - w.DCIA) / 100)
        w.FracPerv = (w.TotalArea - w.ImpArea) / w.TotalArea
END IF
END SUB

DEFINT A-Y
FUNCTION truncate$ (vari AS SINGLE, places AS INTEGER)
vari2! = vari * (10 ^ places) + .5
vari2! = INT(vari2!)
vari2! = vari2! / (10 ^ places)
truncate$ = STR$(vari2!)

END FUNCTION

SUB UnlinkAllNodes (n AS nodetype)

FOR activenode = 1 TO MAXNODES
    IF n.FlowTo(activenode) <> 0 THEN
        FOR i = 1 TO MAXSTEPS: n.NodeInflow(n.FlowTo(activenode), i) = n.NodeInflow(n.FlowTo(activenode), i) - n.NodeOutflow(activenode, i): n.NodeOutflow(activenode, i) = 0: NEXT i
        n.FlowTo(activenode) = 0
    END IF
NEXT activenode
END SUB

SUB UnlinkNode (n AS nodetype)
activenode = GetNode("Unlink what Node?", FALSE, FALSE, n)
IF activenode = 0 OR n.FlowTo(activenode) = 0 THEN EXIT SUB
FOR i = 1 TO MAXSTEPS: n.NodeInflow(n.FlowTo(activenode), i) = n.NodeInflow(n.FlowTo(activenode), i) - n.NodeOutflow(activenode, i): n.NodeOutflow(activenode, i) = 0: NEXT i
n.FlowTo(activenode) = 0
END SUB

