DECLARE FUNCTION truncate$ (vari AS SINGLE, places AS INTEGER)

DEFINT A-Y

' ===========================================================================
'
' SMADA.BAS Copyright (c) 1990 EAGLIN
'
' ===========================================================================


DEFINT A-Y
'$INCLUDE: 'smada.bi'


DECLARE SUB RoutePrintToSub (menu AS INTEGER, item AS INTEGER, W AS WatershedType, R AS RainfallType, H AS HydrographType, pond AS pondtype, p() AS pondtype, n AS nodetype)
DECLARE FUNCTION GetBackStage! (i%, NumBackStages%, BackTime!(), BackStages!())
DECLARE FUNCTION getVal! (n AS INTEGER, xo AS SINGLE, x() AS SINGLE, Y() AS SINGLE)
DECLARE SUB SCSUniform ()
DECLARE SUB UnlinkNode (n AS nodetype)
DECLARE SUB SaveBatchData (n AS nodetype)
DECLARE SUB RetrieveBatchNode (H AS HydrographType, R AS RainfallType, n AS nodetype)
DECLARE SUB DrawHydrograph (n%, H AS HydrographType, R AS RainfallType)
DECLARE SUB GetHelp (H$)
DECLARE SUB MonoDisplay ()
DECLARE SUB ChangeCurrentDirectory ()
DECLARE SUB colordisplay ()
DECLARE SUB CreateRainFile (R AS RainfallType)
DECLARE SUB EditRainFile (R AS RainfallType)
DECLARE SUB GetSTorDisRel ()
DECLARE SUB GetSaveFileName ()
DECLARE SUB MakeDimRainFall (R AS RainfallType)


DECLARE SUB SetupDesktop ()
DECLARE SUB SetupMenu ()
DECLARE SUB ViewHydrograph (NodeFlag%, STEPS%, p() AS pondtype, H AS HydrographType, R AS RainfallType, n AS nodetype)
DECLARE SUB DisplayNodes (n AS nodetype)
DECLARE SUB RetrieveHydroFile (H AS HydrographType, R AS RainfallType)
DECLARE SUB PlotHydrograph (H AS HydrographType, R AS RainfallType)
DECLARE SUB geta ()
DECLARE SUB DeleteFile (FileSpec$)
DECLARE SUB PlotAxis (xmax!, ymax!)
DECLARE SUB PlotSeries (STEPS%, Stepsmax%, Valy!(), ymax!, R AS RainfallType)
DECLARE SUB PlotNode (R AS RainfallType, n AS nodetype)
DECLARE SUB HyetoPlot (xmax!, H AS HydrographType, R AS RainfallType)
DECLARE SUB ChangeActiveNode ()


'       Watershed Manipulation Subroutines

DECLARE SUB ShedCalc (W AS WatershedType)
DECLARE SUB SCSMethod (W AS WatershedType, H AS HydrographType, R AS RainfallType)
DECLARE SUB CreateShedFile (W AS WatershedType)
DECLARE SUB EditShedFile (W AS WatershedType)
DECLARE SUB GetInfiltration (i, W AS WatershedType, H AS HydrographType, R AS RainfallType)
DECLARE SUB SantaBarbara (W AS WatershedType, H AS HydrographType, R AS RainfallType)
DECLARE SUB SCSMethod (W AS WatershedType, H AS HydrographType, R AS RainfallType)
DECLARE SUB GenHydro (W AS WatershedType, p() AS pondtype, H AS HydrographType, R AS RainfallType, n AS nodetype)

'       Pond Manipulation Routines

DECLARE SUB getweirdischarge (p AS pondtype)
DECLARE SUB SaveStorDisrel (pond AS pondtype)
DECLARE SUB RetrieveStorDisRel (pond AS pondtype)
DECLARE SUB MakeStageStorDisrel (pond AS pondtype)
DECLARE SUB EditStorDisrel (pond AS pondtype)
DECLARE SUB DefinePond (pond AS pondtype)

'       Routing Manipulation Routines

DECLARE SUB DefineNode (p() AS pondtype, H AS HydrographType, R AS RainfallType, n AS nodetype)
DECLARE SUB LinkNode (p() AS pondtype, H AS HydrographType, R AS RainfallType, n AS nodetype)
DECLARE SUB UnlinkAllNodes (n AS nodetype)
DECLARE SUB DrawNode (n1%, p() AS pondtype, R AS RainfallType, n AS nodetype)
DECLARE SUB PondRoute (activenode%, pond AS pondtype, R AS RainfallType, n AS nodetype)

DECLARE FUNCTION GetNode% (Message$, FlowToFlag%, ActiveFlag%, n AS nodetype)
DECLARE FUNCTION ControlEditWindow% (EditFields%, ButtonLine%, H$)
DECLARE FUNCTION GetTimeCon% (g%, n1!, S!, q!, Z!, D!, l!, R AS RainfallType, n AS nodetype)
DECLARE FUNCTION GetValue! (a!, Message$)
DECLARE FUNCTION GetLabel$ (default$, Message$)
DECLARE FUNCTION GetDiameter! (Diameter!, activenode%)
DECLARE FUNCTION MultAnswer (n%, a$(), title$)
DECLARE FUNCTION GetAnswer (n%, a$(), title$)

'$INCLUDE: 'general.bi'
'$INCLUDE: 'mouse.bi'
'$INCLUDE: 'menu.bi'
'$INCLUDE: 'window.bi'

COMMON SHARED /uitools/ GloMenu           AS MenuMiscType
COMMON SHARED /uitools/ GloTitle()        AS MenuTitleType
COMMON SHARED /uitools/ GloItem()         AS MenuItemType
COMMON SHARED /uitools/ GloWindow()       AS windowType
COMMON SHARED /uitools/ GloButton()       AS buttonType
COMMON SHARED /uitools/ GloEdit()         AS EditFieldType
COMMON SHARED /uitools/ GloStorage        AS WindowStorageType
COMMON SHARED /uitools/ GloWindowStack()  AS INTEGER
COMMON SHARED /uitools/ GloBuffer$()


COMMON SHARED CurrentPath$
COMMON SHARED SaveFileName$
COMMON SHARED label$
COMMON SHARED HydroFile$
COMMON SHARED WaterFile$
COMMON SHARED RainFile$

COMMON SHARED bar$
COMMON SHARED Message$
COMMON SHARED activenode        AS INTEGER

DIM GloTitle(MAXMENU)           AS MenuTitleType
DIM GloItem(MAXMENU, MAXITEM)   AS MenuItemType
DIM GloWindow(MAXWINDOW)        AS windowType
DIM GloButton(MAXBUTTON)        AS buttonType
DIM GloEdit(MAXEDITFIELD)       AS EditFieldType
DIM GloWindowStack(MAXWINDOW)   AS INTEGER
DIM GloBuffer$(MAXWINDOW + 1, 2)
DIM SHARED DisplayType          AS INTEGER


        DIM H AS HydrographType
        DIM W AS WatershedType
        DIM R AS RainfallType
        DIM n AS nodetype
        DIM p(MAXNODES) AS pondtype
        DIM pond        AS pondtype


bar$ = "        " + STRING$(66, "-")
DIM SHARED help$
DIM SHARED rootdir$
rootdir$ = CURDIR$
help$ = CURDIR$ + "\" + "smhelp.hlp"
STACK (6144)

    ' Initialize Demo

    MenuInit
    WindowInit
    MouseShow
    colordisplay
    ON ERROR GOTO errorhandler

         a$ = "SMADA 4.0 - Stormwater Management and Design Aid|"
    a$ = a$ + "Written by  Ron Eaglin and Marty Wanielista|"
    a$ = a$ + "|"
    a$ = a$ + "Program Team: Greg Harper|"
    a$ = a$ + "                : Marc Gauthier"
    
        a = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        colordisplay

    ' =======================================================================
    ' Main Loop : Stay in loop until DemoFinished set to TRUE
    ' =======================================================================
StartofMainLoop:
    DemoFinished = FALSE

    WHILE NOT DemoFinished
        kbd$ = MenuInkey$
        WHILE MenuCheck(2)
            GOSUB MenuTrap
        MenuOn
        colordisplay
        WEND
    WEND

    ' =======================================================================
    ' End Program
    ' =======================================================================

    MouseHide
    COLOR 15, 0
    CLS
    END



' ===========================================================================
' If a menu event occured, call the proper demo, or if Exit, set demoFinished
' ===========================================================================

MenuTrap:
    menu = MenuCheck(0)
    item = MenuCheck(1)
   
    SELECT CASE menu
        CASE 1
            SELECT CASE item
                CASE 1: GetHelp help$
                CASE 2: ChangeCurrentDirectory
                CASE 3: LPRINT CHR$(12)
                CASE 5: DemoFinished = TRUE
            END SELECT
        CASE 2
            SELECT CASE item
                CASE 1: CreateShedFile W
                CASE 2: EditShedFile W
                CASE 3: RoutePrintToSub menu, item, W, R, H, pond, p(), n
                CASE 4: RoutePrintToSub menu, item, W, R, H, pond, p(), n
                CASE 5: RoutePrintToSub menu, item, W, R, H, pond, p(), n
                CASE 6: RoutePrintToSub menu, item, W, R, H, pond, p(), n
            END SELECT
        CASE 3
            SELECT CASE item
                CASE 1: R.DimFlag = 0: CreateRainFile R
                CASE 2: EditRainFile R
                CASE 3: RoutePrintToSub menu, item, W, R, H, pond, p(), n
                CASE 4: RoutePrintToSub menu, item, W, R, H, pond, p(), n
                CASE 5: RoutePrintToSub menu, item, W, R, H, pond, p(), n
                CASE 6: MakeDimRainFall R
                CASE 7: RoutePrintToSub menu, item, W, R, H, pond, p(), n
            END SELECT
        CASE 4
            SELECT CASE item
                CASE 1: GenHydro W, p(), H, R, n
                CASE 2: ViewHydrograph FALSE, H.HydroSteps, p(), H, R, n
                CASE 3: RoutePrintToSub menu, item, W, R, H, pond, p(), n
                CASE 4: RoutePrintToSub menu, item, W, R, H, pond, p(), n
                CASE 5: PlotHydrograph H, R
                CASE 6: RoutePrintToSub menu, item, W, R, H, pond, p(), n
            END SELECT
        CASE 5
            SELECT CASE item
                CASE 1: DefinePond pond
                CASE 2: EditStorDisrel pond
                CASE 3: RoutePrintToSub menu, item, W, R, H, pond, p(), n
                CASE 4: RoutePrintToSub menu, item, W, R, H, pond, p(), n
            END SELECT
        CASE 6
            SELECT CASE item
                CASE 1: DefineNode p(), H, R, n
                CASE 2: LinkNode p(), H, R, n
                CASE 3: SaveBatchData n
                CASE 4: DisplayNodes n
                CASE 5: RoutePrintToSub menu, item, W, R, H, pond, p(), n
                CASE 6: RoutePrintToSub menu, item, W, R, H, pond, p(), n
                CASE 7: ViewHydrograph TRUE, 90, p(), H, R, n
                CASE 8: UnlinkNode n
                CASE 9: UnlinkAllNodes n

            END SELECT
        CASE 7
            SELECT CASE item
                CASE 1: RoutePrintToSub menu, item, W, R, H, pond, p(), n
                CASE 2: RoutePrintToSub menu, item, W, R, H, pond, p(), n
            END SELECT
        MenuOn
        CASE ELSE
    END SELECT
RETURN

errorhandler:
SELECT CASE ERR
        CASE 25
                a$ = "Printer is not on or is out of paper"
        CASE 55
                a$ = "File Open error Hit Enter to Continue"
                CLOSE
        CASE ELSE
                a$ = "Error " + STR$(ERR)
                RESUME StartofMainLoop
END SELECT
a = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
RESUME

DEFINT Z
SUB ChangeCurrentDirectory

OrigDir$ = CURDIR$
Origdrive$ = LEFT$(CURDIR$, 2)

currentpathtemp$ = GetLabel$(OrigDir$, "Choose New Directory:")
IF LEN(currentpathtemp$) < 2 THEN currentpathtemp$ = OrigDir$
   ON LOCAL ERROR GOTO handler
   junk = Alert(4, "You Chose " + currentpathtemp$, 10, 10, 12, 70, "Continue", "Cancel", "")
   SELECT CASE junk
   CASE 2
        EXIT SUB
   CASE 1
        IF INSTR(1, currentpathtemp$, ":") = 2 THEN
                IF LEN(currentpathtemp$) = 2 THEN currentpathtemp$ = currentpathtemp$ + "\"
                newdrive$ = LEFT$(currentpathtemp$, 2)
                CHDRIVE newdrive$
                CHDIR currentpathtemp$
        ELSE
                CHDIR currentpathtemp$
        END IF
   END SELECT

handler:
    IF ERR = 76 THEN
        junk = Alert(4, "The Directory Could Not Be Found", 10, 10, 12, 70, "OK", "", "")
        CHDRIVE Origdrive$
        CHDIR OrigDir$
        EXIT SUB
    END IF



END SUB

SUB colordisplay
    DisplayType = TRUE
    MouseHide
    SetupMenu
    SetupDesktop
    MenuShow
    MouseShow
END SUB

SUB ContinuousConvolution (W AS WatershedType, H AS HydrographType, R AS RainfallType)
DIM PARQ(30, 30)  AS SINGLE ' MATRIX CONTAINING PARTIAL VALUES OF THE HYDROGRAPH

DIM K           AS SINGLE
DIM i           AS INTEGER
DIM SPRIME      AS SINGLE
K = 1 / W.TimeCon

 DDITemp! = (W.DCIA / W.TotalArea)
 PERIMPtemp! = (W.ImpArea / W.TotalArea) - DDITemp!
 Pervious! = 1 - DDITemp! - PERIMPtemp!
 INFILL! = 0
 tt! = 0
 PRE! = 0
TRUN! = 0
 FOR i = 1 TO R.NumRainSteps
     tt! = tt! + R.RainTimeStep
     RUNDDI! = R.Rain(i) * DDITemp!
     RUNIMP! = R.Rain(i) * PERIMPtemp!
     IF RUNIMP! < 0 THEN RUNIMP! = 0
     RUNPER! = (R.Rain(i) * Pervious! + RUNIMP!)
     IF RUNPER! < 0 THEN RUNPER! = 0
     SPRIME = (1000 / W.CN) - 10
     IF SPRIME < W.MAXINF THEN MAXINFtemp! = SPRIME
     PRE! = PRE! + RUNPER!
     IF PRE! - (.2 * SPRIME) >= 0! THEN TOTRUN! = (PRE! - .2 * SPRIME) ^ 2 / (PRE! + .8 * SPRIME) ELSE TOTRUN! = 0!
     IF (PRE! - TOTRUN!) > MAXINFtemp! THEN TOTRUN! = PRE! - MAXINFtemp!
     RUNOFF! = TOTRUN! - TRUN!
     TRUN! = TOTRUN!
     RUNOFF! = RUNOFF! + RUNDDI!
     H.Excess(i) = (RUNOFF! * W.TotalArea * 60.48) / R.Rain(i)
NEXT i

FOR i = 1 TO R.NumRainSteps
        IF H.Excess(i) = 0 THEN
                FI(i) = 0
                LN(i) = 0
                NUM = 0
        ELSEIF H.Excess(i + 1) = 0 THEN
                IF NUM <= H.Excess(i) THEN
                        FI(i) = (H.Excess(i) - NUM) / 2 + NUM
                        LN(i) = (H.Excess(i) - NUM) / 2 + H.Excess(i)
                ELSEIF NUM - H.Excess(i) > H.Excess(i) THEN
                        LN(i) = 0
                        FI(i) = 2 * H.Excess(i)
                ELSE
                        FI(i) = NUM
                        LN(i) = 2 * H.Excess(i) - NUM
                END IF

        ELSEIF H.Excess(i + 1) > H.Excess(i) THEN
                IF NUM <= H.Excess(i) THEN
                        IF H.Excess(i) - (H.Excess(i + 1) - H.Excess(i)) / 2 >= NUM THEN FI(i) = H.Excess(i) - (H.Excess(i + 1) - H.Excess(i)) / 2 ELSE FI(i) = NUM
                        IF H.Excess(i) - (H.Excess(i + 1) - H.Excess(i)) / 2 >= NUM THEN LN(i) = H.Excess(i) + (H.Excess(i + 1) - H.Excess(i)) / 2 ELSE LN(i) = (2 * H.Excess(i)) - NUM
                        NUM = LN(i)
                ELSE
                        IF (NUM - H.Excess(i)) / 2 <= H.Excess(i) / 2 THEN FI(i) = (NUM - H.Excess(i)) / 2 + H.Excess(i) ELSE FI(i) = H.Excess(i) / 2 + H.Excess(i)
                        IF (NUM - H.Excess(i)) / 2 <= H.Excess(i) / 2 THEN LN(i) = H.Excess(i) - (NUM - H.Excess(i)) / 2 ELSE LN(i) = H.Excess(i) / 2
                        NUM = LN(i)
                END IF

        ELSEIF H.Excess(i + 1) <= H.Excess(i) THEN
                IF NUM <= H.Excess(i) THEN
                        FI(i) = NUM
                        LN(i + 1) = H.Excess(i + 1)
                        LN(i) = (2 * H.Excess(i) * R.RainTimeStep - NUM * R.RainTimeStep + R.RainTimeStep * H.Excess(i + 1)) / (R.RainTimeStep + R.RainTimeStep)
                        FI(i + 1) = LN(i)
                        NUM = H.Excess(i + 1)
                        i = i + 1
                ELSE
                        IF (H.Excess(i) - H.Excess(i + 1)) / 2 + H.Excess(i) >= NUM THEN FI(i) = NUM ELSE FI(i) = (H.Excess(i) - H.Excess(i + 1)) / 2 + H.Excess(i)
                        IF (H.Excess(i) - H.Excess(i + 1)) / 2 + H.Excess(i) >= NUM THEN LN(i) = 2 * H.Excess(i) - NUM ELSE LN(i) = H.Excess(i) - (H.Excess(i) - H.Excess(i + 1)) / 2
                        NUM = LN(i)
                END IF
        END IF
NEXT i


K = 1 / W.TimeCon

S = 0
FOR i = 1 TO NewRainSteps
        D(i) = FI(i)
        E(i) = (LN(i) - FI(i)) / R.RainTimeStep
        S = S + R.RainTimeStep
NEXT i

FOR j = 1 TO NewRainSteps
        i = 2
       tt = R.RainTimeStep
       PARQ(1, j) = 0
       IF j = 1 THEN BN = 0 ELSE BN = BN + R.RainTimeStep
33930  IF ((PARQ(i - 1, j) < .002) AND (tt > S)) OR i > 29 THEN
                Z(j) = i
        ELSEIF tt <= BN THEN
                PARQ(i, j) = 0
                i = i + 1
                tt = tt + R.RainTimeStep
                GOTO 33930
        ELSEIF tt > BN + R.RainTimeStep THEN
                TAO = tt - BN
                IF E(j) = 0 THEN PARQ(i, j) = D(j) * (2.7183 ^ (-K * TAO)) * (2.7183 ^ (K * R.RainTimeStep) - 1)
                IF E(j) <> 0 THEN PARQ(i, j) = D(j) * 2.7183 ^ (-K * TAO) * 2.7183 ^ (K * R.RainTimeStep) - D(j) * 2.7183 ^ (-K * TAO) + E(j) * R.RainTimeStep * 2.7183 ^ (-K * TAO) * 2.7183 ^ (K * R.RainTimeStep) - (E(j) * 2.7183 ^ (-K * TAO) *  _
2.7183 ^ (K * R.RainTimeStep)) / K + (E(j) * 2.7183 ^ (-K * TAO)) / K
                i = i + 1
                tt = tt + R.RainTimeStep
                GOTO 33930
        ELSE
                TAO = tt - BN
                IF E(j) = 0 THEN PARQ(i, j) = D(j) - D(j) * 2.7183 ^ (-K * TAO) ELSE PARQ(i, j) = D(j) - D(j) * 2.7183 ^ (-K * TAO) + E(j) * TAO - E(j) / K + (E(j) * 2.7183 ^ (-K * TAO)) / K
                i = i + 1
                tt = tt + R.RainTimeStep
                GOTO 33930
        END IF
NEXT j

Y = 0
FOR i = 1 TO NewRainSteps
        IF Z(i) >= Y THEN Y = Z(i)
NEXT i

FOR j = 1 TO NewRainSteps
        FOR i = Z(j) TO Y
                PARQ(i, j) = 0
        NEXT i
NEXT j

FOR i = 1 TO Y
        q(i) = 0
        FOR j = 1 TO NewRainSteps
                q(i) = q(i) + PARQ(i, j)
        NEXT j
NEXT i


END SUB

DEFSNG Z
SUB DefineNode (p() AS pondtype, H AS HydrographType, R AS RainfallType, n AS nodetype)
DIM a$(MAXNODES)
DIM b$(5)

b$(1) = "Watershed Node"
b$(2) = "Pond Node"
b$(3) = "Junction Node"
b$(4) = "Final Outlet"
b$(5) = "Batch Data File"
nodetype = GetAnswer(5, b$(), "Choose Node Type")

IF nodetype = 0 THEN EXIT SUB

FOR i = 1 TO MAXNODES
        a$(i) = "Node " + STR$(i):
        IF n.NodeExist(i) = TRUE THEN a$(i) = a$(i) + "  " + n.NodeLabel(i)
NEXT i

NodeNumber = MultAnswer(MAXNODES, a$(), "Choose Number to assign to node")
IF n.NodeExist(NodeNumber) = TRUE THEN junk = Alert(4, "Node is already defined, redefine?", 5, 10, 8, 70, "Yes", "No", "")
IF junk = 2 THEN EXIT SUB
IF junk = 1 THEN FOR i = 1 TO MAXSTEPS: n.NodeInflow(NodeNumber, i) = 0: n.NodeOutflow(activenode, i) = 0: NEXT i

IF NodeNumber = 0 THEN EXIT SUB
activenode = NodeNumber

Message$ = "Enter a Name for Node # " + STR$(NodeNumber)
n.NodeLabel(NodeNumber) = GetLabel$(b$(nodetype), Message$)

IF nodetype = 5 THEN RetrieveBatchNode H, R, n

IF nodetype = 1 THEN
        RetrieveHydroFile H, R
        IF H.HydroSteps = 0 THEN EXIT SUB

        FOR i = 1 TO H.HydroSteps
                n.NodeInflow(NodeNumber, i) = H.Outflow(i)
        NEXT i
END IF

n.NodeExist(NodeNumber) = TRUE
n.nodetype(NodeNumber) = nodetype
IF nodetype = 2 THEN RetrieveStorDisRel p(activenode)
colordisplay

END SUB

SUB DefinePond (pond AS pondtype)

DIM a$(5)
a$(1) = "New Storage Discharge Relation"
a$(2) = "New Outlet Weir Relationship"
a$(3) = "Add Another Weir To Pond"
a$(4) = "Replace Current Weir"
IF pond.numstordisrel = 0 THEN n = 2 ELSE n = 4
temppondtype = GetAnswer(n, a$(), "Define Discharge Method")
SELECT CASE temppondtype
        CASE 0: EXIT SUB
        CASE 1
                GOSUB resetponds
                EditStorDisrel pond
        CASE 2
                GOSUB resetponds
                MakeStageStorDisrel pond
                EditStorDisrel pond

        CASE 3
                pond.invertstage = 0
                MakeStageStorDisrel pond
                EditStorDisrel pond
        CASE 4
                pond.invertstage = 0
                FOR i = 1 TO storrelations
                        pond.discharge(i) = 0
                NEXT i
                MakeStageStorDisrel pond
                EditStorDisrel pond

END SELECT
EXIT SUB
resetponds:
        IF pond.numstordisrel <> 0 THEN
                a1$ = "This will overwrite your previous pond information."
                a1$ = a1$ + "|Do you wish to continue or edit existing relationship ?"
                dummy = Alert(4, a1$, 10, 10, 16, 70, "YES", "NO", "EDIT")
                IF dummy = 2 THEN EXIT SUB
                IF dummy = 3 THEN RETURN
        END IF

                pond.minstage = 0
                pond.initstage = 0
                pond.stageint = 0
                pond.numstordisrel = 0
                FOR i = 1 TO storrelations
                        pond.srfarea(i) = 0
                        pond.stage(i) = 0
                        pond.storage(i) = 0
                        pond.discharge(i) = 0
                NEXT i
RETURN

END SUB

SUB DisplayNodes (n AS nodetype)
MenuOff

ContinueFlag = FALSE
FOR i = 1 TO MAXNODES
        IF n.NodeExist(i) = TRUE THEN ContinueFlag = TRUE
NEXT i
IF ContinueFlag = FALSE THEN
        a1$ = "There are no nodes defined. To save data you first"
        a1$ = a1$ + "|must define and link your nodes."
        junk = Alert(4, a1$, 10, 10, 16, 70, "", "Continue", "")
        EXIT SUB
END IF


a$ = "Defined Nodes| |"
FOR i = 1 TO MAXNODES
        IF n.NodeExist(i) = TRUE THEN

                a$ = a$ + "Node:" + STR$(i) + " (" + n.NodeLabel(i) + ")"
                IF n.NodeExist(n.FlowTo(i)) = TRUE THEN
                        a$ = a$ + " Flows to Node:" + STR$(n.FlowTo(i)) + " (" + n.NodeLabel(n.FlowTo(i)) + ")"
                ELSE
                        IF n.FlowTo(i) <> 0 THEN
                                a$ = a$ + " Flows to Node:" + STR$(n.FlowTo(i)) + " (Undefined)"
                        ELSE
                                a$ = a$ + " is not linked"
                        END IF
                END IF
                a$ = a$ + "|"
        END IF
NEXT i
junk = Alert(4, a$, 5, 3, 21, 77, "", "", "")
END SUB

SUB DrawHydrograph (n, H AS HydrographType, R AS RainfallType)
DIM TotalRunoff2 AS SINGLE
DIM TotalOutflow2 AS SINGLE
WindowCls
windowlocate 1, 2
windowprint 2, "  Time    Rainfall    Infiltration        Hydrographs in cfs"
windowlocate 2, 2
windowprint 2, " Hours     (in)          (in)         Instantaneous      Outflow"
windowline 3
FOR i = 1 TO 16
windowlocate i + 3, 2
windowprint 1, STR$(INT(R.RainTimeStep * (i + n) * 5 / 3) / 100)
windowlocate i + 3, 12
windowprint 1, STR$(R.Rain(i + n))
windowlocate i + 3, 25
windowprint 1, truncate$(H.infiltration(i + n), 2)
windowlocate i + 3, 42
windowprint 1, truncate$(H.RUNOFF(i + n), 2)
windowlocate i + 3, 58
windowprint 1, truncate$(H.Outflow(i + n), 2)
NEXT i
windowline 19
windowlocate 20, 2
windowprint 2, "Total ---"
windowlocate 20, 12
windowprint 2, truncate$(R.TotalRain, 2)
windowlocate 20, 42
TotalRunoff2 = H.TotalRunoff * R.RainTimeStep * 60
windowprint 2, STR$(TotalRunoff2) + " cf"
windowlocate 20, 58
TotalOutflow2 = H.TotalOutflow * R.RainTimeStep * 60
windowprint 2, STR$(TotalOutflow2) + " cf"
windowlocate 21, 2
windowprint -2, "Rational Coefficient = " + STR$(H.RatCoeff)
windowlocate 21, 46
windowprint -2, "Peak Flow = " + truncate$(H.PeakOutflow, 2) + " cfs"
END SUB

SUB DrawNode (n1%, p() AS pondtype, R AS RainfallType, n AS nodetype)
WindowCls
windowlocate 1, 2
windowprint 2, "            Time        Rain        Node Inflow        Node Outflow"
windowlocate 2, 2
windowprint 2, "            Hours        (in)         (cfs)              (cfs)"
windowline 3
FOR i = 1 TO 16
n.NodeInflow(activenode, i + n1) = FIX(n.NodeInflow(activenode, i + n1) * 1000) / 1000
n.NodeOutflow(activenode, i + n1) = FIX(n.NodeOutflow(activenode, i + n1) * 1000) / 1000
windowlocate i + 3, 12
windowprint 1, STR$(INT(R.RainTimeStep * (i + n1) * 5 / 3) / 100)
windowlocate i + 3, 24
windowprint 1, STR$(R.Rain(i + n1))
windowlocate i + 3, 36
windowprint 1, truncate$(n.NodeInflow(activenode, (i + n1)), 2)
windowlocate i + 3, 54
windowprint 1, truncate$(n.NodeOutflow(activenode, (i + n1)), 2)
NEXT i
windowline 19
SELECT CASE n.nodetype(activenode)
        CASE 1, 3, 5
                SELECT CASE n.nodetype(activenode)
                       CASE 3: b$ = "Node :" + STR$(activenode) + "   Junction Node"
                       CASE 5: b$ = "Node :" + STR$(activenode) + "   Batch Node"
                       CASE 1: b$ = "Node :" + STR$(activenode) + "   Watershed Node"
                END SELECT
                SELECT CASE n.NodeGeometry(activenode)
                        CASE 1
                                b$ = b$ + "   Pipe Outlet"
                                a$ = "Length :" + STR$(n.Length(activenode))
                                a$ = a$ + " ft   Diameter: " + STR$(n.Diameter(activenode)) + " ft"
                                a$ = a$ + "   Velocity (full flow) = " + STR$(n.Velocity(activenode)) + " fps"
                        CASE 2
                                 b$ = b$ + " Length :" + STR$(n.Length(activenode)) + " ft"
                                 b$ = b$ + "   Velocity:" + STR$(n.Velocity(activenode)) + "  fps"
                                 a$ = "Depth:" + STR$(n.Depth(activenode))
                                 a$ = a$ + " ft   Bottom Width:" + STR$(n.Bas(activenode))
                                 a$ = a$ + " ft   Side slope:" + STR$(n.SideSlope(activenode))
                                 a$ = a$ + " v/h"
                        END SELECT
        CASE 2
                 b$ = "Node :" + STR$(activenode) + "   Pond Node"
                 x! = FIX(p(activenode).MaxVolume * 1000 / 43560) / 1000
                 a$ = "Maximum Volume = " + STR$(x!) + " ac-ft  Maximum Stage = " + STR$(p(activenode).MaxStage) + " ft"
        CASE 4
                 b$ = "Node :" + STR$(activenode) + "    Outlet Node"
END SELECT
windowlocate 20, 2
windowprint -1, b$
windowlocate 21, 2
windowprint -1, a$

END SUB

SUB GenHydro (W AS WatershedType, p() AS pondtype, H AS HydrographType, R AS RainfallType, n AS nodetype)
DIM a$(5)

IF W.infmeth = 0 THEN
        a$ = "You must create or retrieve a watershed before generating "
        a$ = a$ + "|a Hydrograph, Use Create or Retrieve Watershed"
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        EXIT SUB
END IF

IF R.RainTimeStep = 0 THEN
        a$ = "You must Create or Retrieve a rainfall"
        a$ = a$ + "| before Generating a Hydrograph"
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        EXIT SUB
END IF

a$(1) = "Santa Barbara Method"
a$(2) = "Discrete Unit Convolution"
a$(3) = "Rational Method"
a$(4) = "SCS 484 Curvilinear Unit"
a$(5) = "SCS 256 Curvilinear Unit"
choice = GetAnswer(5, a$(), "Choose Generation Method:")
IF choice = 0 THEN EXIT SUB
H.TotalArea = W.TotalArea
H.hydrotype = a$(choice)
FOR i = 1 TO MAXSTEPS
        H.Outflow(i) = 0
        H.RUNOFF(i) = 0
NEXT i

IF choice = 3 THEN
        a$ = "When Using the Rational Method, the time of concentration,|"
        a$ = a$ + "the rainfall time step, and the rainfall duration should|"
        a$ = a$ + "be of equal duration. If these are not equal then the|"
        a$ = a$ + "Discrete Unit Convolution Method with 645 Attenuation|"
        a$ = a$ + "Factor will be used."
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
END IF

H.HydroSteps = 0
W.SmoothFlag = FALSE
SELECT CASE choice
        CASE 0: EXIT SUB
        CASE 1: SantaBarbara W, H, R
        CASE 2: H.PeakAttFact = 0: SCSMethod W, H, R
        CASE 3: H.PeakAttFact = 645: SCSMethod W, H, R
        CASE 4: H.PeakAttFact = 484: W.SmoothFlag = TRUE: SCSMethod W, H, R
        CASE 5: H.PeakAttFact = 256: W.SmoothFlag = TRUE: SCSMethod W, H, R
END SELECT

IF H.HydroSteps = 0 THEN EXIT SUB
H.TotalRunoff = 0
H.TotalOutflow = 0
FOR i = 1 TO H.HydroSteps
        H.TotalOutflow = H.TotalOutflow + H.Outflow(i)
        H.TotalRunoff = H.TotalRunoff + H.RUNOFF(i)
        IF H.Outflow(i) < 0 THEN H.Outflow(i) = 0
        IF H.Outflow(i) > H.PeakOutflow THEN H.PeakOutflow = H.Outflow(i)
NEXT i

HydroFile$ = "Unnamed " + a$(choice)
IF R.TotalRain <> 0 THEN H.RatCoeff = H.TotalExcess / R.TotalRain
H.RatCoeff = FIX(H.RatCoeff * 1000) / 1000
ViewHydrograph FALSE, H.HydroSteps, p(), H, R, n

END SUB

FUNCTION GetDiameter! (Diameter!, activenode%)
REDIM a$(2)
a$ = "Required Diameter =" + STR$(Diameter!) + " in"
a$(1) = "Use Standard Diameter"
a$(2) = "Input Custom Diameter"
Diachoice = GetAnswer(2, a$(), a$)
IF Diachoice = 1 THEN
        WHILE Diameter! > standardPipe
                standardPipe = 9 + 3 * i
                IF i > 7 THEN standardPipe = 30 + (i - 7) * 6
                IF i > 12 THEN standardPipe = 60 + (i - 12) * 12
                i = i + 1
        WEND
        GetDiameter! = standardPipe
ELSE
        GetDiameter! = VAL(GetLabel$("", "Input Diameter in Inches"))
END IF
END FUNCTION

DEFSNG A-H, J-Y
SUB GetInfiltration (i, W AS WatershedType, H AS HydrographType, R AS RainfallType)

DIM PotentialInfiltration               AS SINGLE
STATIC TotalPerviousRainfall            AS SINGLE
STATIC CumulativeInfiltration           AS SINGLE
STATIC CumulativePerviousAbstraction    AS SINGLE
STATIC CumulativeImperviousAbstraction  AS SINGLE
STATIC CumulativePerviousExcess         AS SINGLE
STATIC LastCumulativePerviousRunoff     AS SINGLE
STATIC CumulativePerviousRunoff         AS SINGLE
STATIC ImperviousExcess                 AS SINGLE
STATIC PerviousExcess                   AS SINGLE
STATIC ImpervioustoPerviousExcess       AS SINGLE
DIM j                                   AS INTEGER
STATIC DummyCumInf                      AS SINGLE
STATIC PerviousRunoff                   AS SINGLE
STATIC ImperviousRunoff                 AS SINGLE

IF i = 1 THEN
        CumulativePerviousExcess = 0
        CumulativePerviousRunoff = 0
        CumulativeInfiltration = 0
        CumulativeImperviousAbstraction = 0
        ImperviousExcess = 0
        H.TotalExcess = 0
        R.TotalRain = 0
        TotalPerviousRainfall = 0
        H.TotalRunoff = 0
        H.TotalInfiltration = 0
        PerviousExcess = 0
        LastCumulativePerviousRunoff = 0
END IF

R.TotalRain = R.TotalRain + R.Rain(i)
TIME = i * R.RainTimeStep

'       **  Routing of Abstraction on Impervious Surface **

IF W.AddAbsImp > R.TotalRain THEN
        ImperviousExcess = 0
        CumulativeImperviousAbstraction = CumulativeImperviousAbstraction + R.Rain(i)

ELSEIF R.TotalRain - R.Rain(i) < W.AddAbsImp AND R.TotalRain > W.AddAbsImp THEN
        ImperviousExcess = R.Rain(i) - (W.AddAbsImp - CumulativeImperviousAbstraction)
        CumulativeImperviousAbstraction = W.AddAbsImp
        IF ImperviousExcess < 0 THEN ImperviousExcess = 0

ELSE
        ImperviousExcess = R.Rain(i)
        IF ImperviousExcess < 0 THEN ImperviousExcess = 0
END IF

ImpervioustoPerviousExcess = W.FracNDCIA * ImperviousExcess * W.TotalArea / (W.TotalArea - W.ImpArea)
ImperviousRunoff = ImperviousExcess
PerviousRainfall = R.Rain(i) + ImpervioustoPerviousExcess
TotalPerviousRainfall = PerviousRainfall + TotalPerviousRainfall

'       **      Routing of Abstraction on Pervious Surface      **

IF W.addabsPerv > TotalPerviousRainfall THEN
        PerviousExcess = 0
        CumulativePerviousAbstraction = TotalPerviousRainfall
ELSE
        PerviousExcess = PerviousRainfall + (CumulativePerviousAbstraction - W.addabsPerv)
        CumulativePerviousAbstraction = W.addabsPerv
END IF

CumulativePerviousExcess = CumulativePerviousExcess + PerviousExcess

IF W.infmeth = 2 THEN
        ExitFlag = FALSE
        j = 0
        WHILE NOT ExitFlag
                DummyCumInf = ((W.HIC * j * R.RainTimeStep) / 60! + (W.HIO - W.HIC) * (1 - EXP(-W.HK * j * R.RainTimeStep / 60))) / W.HK
                IF CumulativeInfiltration > DummyCumInf THEN
                        j = j + 1
                ELSE
                        DummyTime = j * R.RainTimeStep / 60!
                        ExitFlag = TRUE
                END IF
        WEND
        PotentialInfiltration = (W.HIC + (W.HIO - W.HIC) * EXP(-W.HK * DummyTime)) * R.RainTimeStep / 60

        IF CumulativeInfiltration < W.MAXINF THEN
                IF PerviousExcess > PotentialInfiltration THEN
                        PerviousRunoff = PerviousExcess - PotentialInfiltration
                        H.infiltration(i) = PotentialInfiltration
                ELSE
                        PerviousRunoff = 0
                        H.infiltration(i) = PerviousExcess
                END IF
        ELSE
                H.infiltration(i) = 0
        END IF
END IF

IF W.infmeth = 3 THEN
        SPRIME = 1000 / W.CN - 10
        AbsFact = W.InitAbs * SPRIME
        IF CumulativePerviousExcess > AbsFact THEN
                CumulativePerviousRunoff = ((CumulativePerviousExcess - AbsFact) ^ 2) / (CumulativePerviousExcess + (1 - W.InitAbs) * SPRIME)
                PerviousRunoff = CumulativePerviousRunoff - LastCumulativePerviousRunoff
                LastCumulativePerviousRunoff = CumulativePerviousRunoff
                IF CumulativeInfiltration < W.MAXINF THEN
                        H.infiltration(i) = PerviousExcess - PerviousRunoff
                ELSE
                        H.infiltration(i) = 0
                        PerviousRunoff = PerviousExcess
                END IF
        ELSE
                IF CumulativeInfiltration < W.MAXINF THEN
                        PerviousRunoff = 0
                        H.infiltration(i) = PerviousExcess
                ELSE
                        PerviousRunoff = PerviousExcess
                        H.infiltration(i) = 0
                END IF
        END IF
END IF

CumulativeInfiltration = CumulativeInfiltration + H.infiltration(i)
H.infiltration(i) = H.infiltration(i) * W.FracPerv
H.Excess(i) = W.FracDCIA * ImperviousRunoff + W.FracPerv * PerviousRunoff
H.TotalExcess = H.Excess(i) + H.TotalExcess
H.RUNOFF(i) = 60 * H.Excess(i) * W.TotalArea * 1.008 / R.RainTimeStep
H.TotalInfiltration = H.TotalInfiltration + H.infiltration(i)

END SUB

DEFINT A-H, J-Y
FUNCTION GetNode (Message$, FlowToFlag, ActiveFlag, n AS nodetype)
' FlowToFlag -  Enables checking for other nodes flowing to node and does not list
' ActiveFlag -  Does not list current Active Node

DIM a(MAXNODES)
REDIM a$(MAXNODES)

LastActiveNode = activenode

j = 1
FOR i = 1 TO MAXNODES
        IF FlowToFlag = TRUE AND n.FlowTo(i) = 0 THEN FlowFlag = TRUE
        IF FlowToFlag = FALSE THEN FlowFlag = TRUE
        IF i = activenode AND ActiveFlag = TRUE THEN ActFlag = FALSE ELSE ActFlag = TRUE
        IF n.NodeExist(i) = TRUE AND FlowFlag = TRUE AND ActFlag = TRUE THEN
                a$(j) = "Node " + STR$(i) + "  " + n.NodeLabel(i)
                a(j) = i
                j = j + 1
        END IF
NEXT i

j = j - 1
IF j = 0 THEN GetNode = 0: EXIT FUNCTION
DummyNode = MultAnswer(j, a$(), Message$)
DummyNode = a(DummyNode)
GetNode = DummyNode
colordisplay
END FUNCTION

SUB GetSaveFileName
SaveFileName$ = ""
Direct$ = CURDIR$ + "\"
SaveFileName$ = GetLabel$(Direct$, "Enter a File Name (no Extension)")

IF INSTR(SaveFileName$, " ") OR INSTR(SaveFileName$, ".") THEN
        junk = Alert(4, "Illegal File Name|Do not use spaces or . in filename", 5, 10, 8, 70, "", "", "")
        GetSaveFileName
END IF
END SUB

FUNCTION GetTimeCon (g%, n1!, S!, q!, Z!, D!, l!, R AS RainfallType, n AS nodetype)
STATIC Y!
ON LOCAL ERROR GOTO tchandler
IF n.NodeGeometry(activenode) = 2 THEN
        IF Y! = 0 THEN Y! = 2: incr! = .1
        fy! = 1
        WHILE ABS(fy!) > .001
                dum1! = ((D! + Z! * Y!) * Y! / (D! + 2 * Y! * (1 + Z! ^ 2) ^ .5)) ^ .6667
                fy! = (D! * Y! * (1.486 / n1!) * dum1! * S! ^ .5) - q!
                IF SGN(fy!) <> SGN(fy2!) THEN incr! = incr! / 2
                IF fy! > 0 THEN Y! = Y! - incr! ELSE Y! = Y! + incr!
                IF incr! = 0 THEN incr! = .1
                fy2! = fy!
        WEND
        v! = q! / ((D! + Z! * Y!) * Y!)
        IF Y! > n.Depth(activenode) THEN n.Depth(activenode) = Y!
ELSE
        IF Y! = 0 THEN Y! = 1.55
        incr! = .1
        fy! = 1
        WHILE ABS(fy!) > .001
                fy! = (1 / 8) * (Y! - SIN(Y!)) * D! ^ 2 * (1.486 / n1!) * (.25 * (1 - SIN(Y!) / Y!) * D!) ^ .6667 * S! ^ .5 - n.NodeInflow(activenode, 1)
                IF SGN(fy!) <> SGN(fy2!) THEN incr! = incr! / 2
                IF fy! > 0 THEN Y! = Y! - incr! ELSE Y! = Y! + incr!
                IF incr! = 0 THEN incr! = .1
                fy2! = fy!
        WEND
        IF Y! > .1 THEN v! = q! / ((Y! - SIN(Y!) / 8) * D! ^ 2)
END IF
IF v! > n.Velocity(activenode) THEN n.Velocity(activenode) = v!
IF v! > .01 THEN a = CINT(l! / (v! * 60))
IF v! = 0 THEN a = R.RainTimeStep
GetTimeCon = a
EXIT FUNCTION
tchandler:
        a$ = "Error !! Parameter Overflow|To Correct, Unlink Node and Relink using another method."
        junk = Alert(4, a$, 9, 10, 14, 70, "", "", "")
        GetTimeCon = -1
        EXIT FUNCTION
END FUNCTION

FUNCTION getVal! (n AS INTEGER, xo AS SINGLE, x() AS SINGLE, Y() AS SINGLE)

i = n
        WHILE xo < x(i) AND i > 0
                i = i - 1
        WEND
        
        IF i < n THEN
                IF x(i + 1) <> x(i) THEN
                        m! = (Y(i + 1) - Y(i)) / (x(i + 1) - x(i))
                ELSE
                        m! = 0
                END IF

        ELSE
                IF x(i - 1) <> x(i) THEN
                        m! = (Y(i) - Y(i - 1)) / (x(i) - x(i - 1))
                ELSE
                        m! = 0
                END IF

        END IF
        b! = Y(i) - m! * x(i)
        getVal! = m! * xo + b!

END FUNCTION

SUB getweirdischarge (p AS pondtype)
REDIM a$(5)

a$(1) = "60 degree V-Notch Weir"
a$(2) = "90 degree V-Notch Weir"
a$(3) = "Sharp Crested Rectangular Weir"
a$(4) = "Broad Crested Weir"
a$(5) = "Orifice"

weirtyp = GetAnswer(5, a$(), "Define Weir Type")
IF weirtyp = 0 THEN EXIT SUB

        SELECT CASE weirtyp
                CASE 1 TO 2  ' 60 Degree V-Notch
                        IF weirtyp = 1 THEN dc! = 1.43 ELSE dc! = 2.5
                        Discoeff! = GetValue!(dc!, "Input Discharge Coefficient")
                        power! = 2.5
                CASE 3 TO 4 'Rectangular Weir
                        bse! = GetValue(1, "Input Base Length (ft)")
                        IF weirtyp = 3 THEN defdiscoeff! = 3.33 ELSE defdiscoeff! = 3.087
                        Discoeff! = GetValue!(defdiscoeff!, "Input Discharge Coefficient")
                        power! = GetValue!(1.5, "Input Weir power coefficient")
                        IF weirtyp = 3 THEN defendcon! = 2! ELSE defendcon! = 0!
                        endcon! = GetValue!(defendcon!, "Number of End Contractions")
                CASE 5  'Orifice
                        bse! = 0!
                        OrifCoeff! = GetValue!(.6, "Input Orifice Coefficient")
                        area! = GetValue!(0, "Input orifice area (ft^2)")
                        Discoeff! = OrifCoeff! * area!
                        factor! = 0!
                        power! = 1.5

                END SELECT

                FOR j = 1 TO p.numstordisrel
                        height! = p.stage(j) - p.invertstage
                        IF height! > 0 THEN
                                SELECT CASE weirtyp
                                CASE 1 TO 2' 60/90 degree V-Notch
                                        p.discharge(j) = p.discharge(j) + Discoeff! * (height! ^ power!)
                                CASE 3 TO 4
                                        p.discharge(j) = p.discharge(j) + Discoeff! * (height! ^ power!) * (bse! + .2 * height!)
                                CASE 5
                                        height! = 2 * 32.2 * height!
                                        p.discharge(j) = p.discharge(j) + Discoeff! * (height! ^ power!)
                                END SELECT
                        END IF
                NEXT j
END SUB

SUB LinkNode (p() AS pondtype, H AS HydrographType, R AS RainfallType, n AS nodetype)
DIM PeakNodeInflow      AS SINGLE
DIM c                   AS SINGLE
DIM Depth               AS SINGLE
DIM Manning             AS SINGLE
DIM Diameter            AS SINGLE
DIM Slope               AS SINGLE
DIM Bottom              AS SINGLE
DIM Length              AS SINGLE
DIM a(MAXNODES)
REDIM a$(MAXNODES)

ContinueFlag = FALSE
FOR i = 1 TO MAXNODES
        IF n.NodeExist(i) = TRUE THEN ContinueFlag = TRUE
NEXT i
IF ContinueFlag = FALSE THEN
        a1$ = "There are no nodes defined. To link nodes"
        a1$ = a1$ + "|first go to the Define nodes routine and"
        a1$ = a1$ + "|define all your nodes, after the nodes are"
        a1$ = a1$ + "|defined then use the link routine, don't"
        a1$ = a1$ + "|forget to define your final outlet."
        junk = Alert(4, a1$, 10, 10, 16, 70, "", "Continue", "")
        EXIT SUB
END IF

activenode = GetNode("Enter Source Node Number", TRUE, FALSE, n)
IF activenode = 0 THEN EXIT SUB

n.FlowTo(activenode) = GetNode("Enter Reception Node Number", TRUE, TRUE, n)
IF n.FlowTo(activenode) = 0 THEN EXIT SUB

a$(1) = "Circular"
a$(2) = "Trapezoidal"
a$(3) = "No Transport Structure"

IF n.nodetype(activenode) = 1 OR n.nodetype(activenode) = 3 OR n.nodetype(activenode) = 5 THEN
        n.NodeGeometry(activenode) = GetAnswer(3, a$(), "Choose Transport Geometry")
END IF

IF n.NodeGeometry(activenode) = 1 OR n.NodeGeometry(activenode) = 2 THEN
        n.Slope(activenode) = VAL(GetLabel$("", "Enter The Slope as a fraction"))
        Manning = VAL(GetLabel$(".013", "Enter Manning's Coefficient"))
        Length = VAL(GetLabel$("", "Enter the channel/pipe length in feet"))
        IF Length <= 0 THEN n.NodeGeometry(activenode) = 3
        IF n.NodeGeometry(activenode) = 2 THEN SideSlopes! = VAL(GetLabel$(".25", "Enter side slope vert/horiz"))
END IF

FOR j = 1 TO MAXSTEPS
        IF n.NodeInflow(activenode, j) > PeakNodeInflow THEN PeakNodeInflow = n.NodeInflow(activenode, j)
        IF n.NodeGeometry(activenode) = 3 THEN
                n.NodeOutflow(activenode, j) = n.NodeInflow(activenode, j)
                n.NodeInflow(n.FlowTo(activenode), j) = n.NodeOutflow(activenode, j) + n.NodeInflow(n.FlowTo(activenode), j)
        END IF
NEXT j

IF n.NodeGeometry(activenode) = 3 THEN colordisplay: EXIT SUB
IF n.nodetype(activenode) = 2 THEN PondRoute activenode, p(activenode), R, n: colordisplay: EXIT SUB

IF n.NodeGeometry(activenode) = 1 THEN
        Diameter = 12 * (PeakNodeInflow * Manning * 2.16 / n.Slope(activenode) ^ .5) ^ .375
        Diameter = GetDiameter(Diameter, activenode)
        
        D! = Diameter / 12
        junk = Alert(4, "Diameter Used = " + STR$(Diameter) + " in", 9, 10, 14, 70, "", "", "")
END IF

IF n.NodeGeometry(activenode) = 2 THEN
        Z! = 1 / SideSlopes!
        c! = 2 * ((SQR(1 + Z! ^ 2)) - (Z!))
        Depth = (PeakNodeInflow * Manning * 1.07 / ((c! + Z!) * n.Slope(activenode) ^ .5)) ^ .375
        Bottom = c! * Depth
        D! = Bottom
        IF D! = 0 THEN D! = 1
        NodeTimeCon = GetTimeCon(2, Manning, n.Slope(activenode), n.NodeInflow(activenode, 1), Z!, D!, Length, R, n)
        IF NodeTimeCon = -1 THEN EXIT SUB
END IF

i = 1
n.NodeOutflow(activenode, 0) = 0

WHILE STEPS < MAXSTEPS
        IF n.NodeInflow(activenode, i) > .001 THEN
                NodeTimeCon = GetTimeCon(n.NodeGeometry(activenode), Manning, n.Slope(activenode), n.NodeInflow(activenode, i), Z!, D!, Length, R, n)
                IF NodeTimeCon = -1 THEN EXIT SUB
        ELSE
                NodeTimeCon = 0
        END IF
        H.KR = CSNG(R.RainTimeStep / (2 * NodeTimeCon + R.RainTimeStep))
        n.NodeOutflow(activenode, i) = n.NodeOutflow(activenode, i - 1) + H.KR * (n.NodeInflow(activenode, i - 1) + n.NodeInflow(activenode, i) - 2 * n.NodeOutflow(activenode, i - 1))
        IF n.NodeOutflow(activenode, i) > n.PeakNodeOutflow THEN n.PeakNodeOutflow = n.NodeOutflow(activenode, i): p(activenode).peakstep = i
        IF Offset = 0 THEN Offset = NodeTimeCon / R.RainTimeStep
        i = i + 1
        STEPS = i
        LOCATE 5, 15
        PRINT 2, "Routing in Progress Step:" + STR$(i) + "   "
WEND

IF Offset > 0 THEN Offset = Offset - 1
IF STEPS + Offset > MAXSTEPS - 2 THEN STEPS = MAXSTEPS - 2 - Offset

FOR i = Offset + STEPS TO Offset STEP -1
        n.NodeOutflow(activenode, i) = n.NodeOutflow(activenode, i - Offset)
        IF n.NodeInflow(activenode, i) < .0001 * n.PeakNodeOutflow THEN n.NodeInflow(activenode, i) = 0
        IF n.NodeOutflow(activenode, i) < .0001 * n.PeakNodeOutflow THEN n.NodeOutflow(activenode, i) = 0
NEXT i

FOR i = 1 TO Offset
        n.NodeOutflow(activenode, i) = 0
NEXT i

FOR j = 1 TO MAXSTEPS
        IF n.NodeOutflow(activenode, j - 1) < .01 AND n.NodeOutflow(activenode, j) > .01 AND j > p(activenode).peakstep THEN n.NodeOutflow(activenode, j) = 0
        n.NodeInflow(n.FlowTo(activenode), j) = n.NodeOutflow(activenode, j) + n.NodeInflow(n.FlowTo(activenode), j)
NEXT j


n.Length(activenode) = Length
n.Diameter(activenode) = D!
n.Bas(activenode) = Bottom
IF Z! <> 0 THEN n.SideSlope(activenode) = 1 / Z!

colordisplay
END SUB

SUB MakeDimRainFall (R AS RainfallType)
REDIM a$(5)
DIM DimTime             AS SINGLE
DIM RainLastStep        AS SINGLE
DIM TotalPrecip         AS SINGLE
DIM Precip              AS SINGLE
DIM ActualPrecip        AS SINGLE
R.DimFlag = 1
a$(1) = "SCS Type II"
a$(2) = "SCS Type II FL"
a$(3) = "SCS Type III"
a$(4) = "Orange County FL-24 hr"
disttype = GetAnswer(4, a$(), "Choose Curve Type")
IF disttype = 0 THEN EXIT SUB

StartofMakeDimRainFall:
TotalPrecip = VAL(GetLabel$("", "Input Total Precipitation (in):"))
IF TotalPrecip = 0 THEN EXIT SUB
IF TotalPrecip > 20! THEN
        a$ = "This is an unreasonably large amount of"
        a$ = a$ + "|rainfall, please correct amount."
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        GOTO StartofMakeDimRainFall
END IF

IF disttype <> 4 THEN
        CreateRainFile R
ELSE
        R.RainTimeStep = 30
        R.RainDuration = 24
        R.NumRainSteps = R.RainDuration * 60 / R.RainTimeStep + .5
END IF

RainLastStep = 0
LOCATE 2, 2
FOR i = 1 TO R.NumRainSteps
        DimTime = i * R.RainTimeStep / (R.RainDuration * 60)
        IF disttype = 1 THEN
                IF DimTime <= 1 THEN Precip = .0178 + 1.893 * DimTime - .9192 * DimTime ^ 2
                IF DimTime = .5 THEN Precip = .663
                IF DimTime < .5 THEN Precip = 22.394 - 101.8 * DimTime + 116.5 * DimTime ^ 2
                IF DimTime < .44 THEN Precip = .4395 * DimTime ^ 1.195
                IF DimTime < .0271 THEN Precip = .226 * DimTime
                
        END IF
        IF disttype = 2 THEN
                IF DimTime <= 1 THEN Precip = -.0508 + 2.0277 * DimTime - .9855 * DimTime ^ 2
                IF DimTime = .5 THEN Precip = .607
                IF DimTime < .5 THEN Precip = .00953 + .0726 * DimTime + .9643 * DimTime ^ 2
                IF DimTime < .0271 THEN Precip = .226 * DimTime
        END IF
        IF disttype = 3 THEN
                IF DimTime <= 1 THEN Precip = 1.003 * DimTime ^ .2657
                IF DimTime < .7 THEN Precip = -3.8077 + 13.7517 * DimTime - 10.009 * DimTime ^ 2
                IF DimTime = .5 THEN Precip = .5
                IF DimTime <= .5 THEN Precip = .01 * EXP(7.212 * DimTime)
                IF DimTime < .0271 THEN Precip = .224 * DimTime
        END IF
        IF disttype = 4 THEN
                SELECT CASE i
                        CASE 1: Precip = .0013: CASE 2: Precip = .0027: CASE 3: Precip = .004
                        CASE 4: Precip = .008: CASE 5: Precip = .013: CASE 6: Precip = .021
                        CASE 7: Precip = .034: CASE 8: Precip = .049: CASE 9: Precip = .07
                        CASE 10: Precip = .091: CASE 11: Precip = .113: CASE 12: Precip = .136
                        CASE 13: Precip = .183: CASE 14: Precip = .236: CASE 15: Precip = .304
                        CASE 16: Precip = .386: CASE 17: Precip = .49: CASE 18: Precip = .593
                        CASE 19: Precip = .666: CASE 20: Precip = .736: CASE 21: Precip = .772
                        CASE 22: Precip = .809: CASE 23: Precip = .832: CASE 24: Precip = .854
                        CASE 25: Precip = .876: CASE 26: Precip = .898: CASE 27: Precip = .913
                        CASE 28: Precip = .927: CASE 29: Precip = .933: CASE 30: Precip = .939
                        CASE 31: Precip = .944: CASE 32: Precip = .949: CASE 33: Precip = .953
                        CASE 34: Precip = .958: CASE 35: Precip = .963: CASE 36: Precip = .968
                        CASE 37: Precip = .972: CASE 38: Precip = .976: CASE 39: Precip = .979
                        CASE 40: Precip = .983: CASE 41: Precip = .985: CASE 42: Precip = .988
                        CASE 43: Precip = .99: CASE 44: Precip = .993: CASE 45: Precip = .9955
                        CASE 46: Precip = .998: CASE 47: Precip = .999: CASE 48: Precip = 1!
                END SELECT
        END IF
        RainThisStep! = Precip * TotalPrecip
        R.Rain(i) = (RainThisStep! - RainLastStep)
        IF R.Rain(i) < .01 THEN R.Rain(i) = .01
        R.Rain(i) = INT(R.Rain(i) * 100 + .5) / 100
        RainLastStep = RainThisStep!

NEXT i
ActualPrecip = 0


FOR i = 1 TO R.NumRainSteps
        IF R.Rain(i) > m! THEN m! = R.Rain(i): mi = i
        ActualPrecip = ActualPrecip + R.Rain(i)
        IF R.Rain(i) < 0 THEN R.Rain(i) = 0
NEXT i
IF TotalPrecip <> ActualPrecip THEN
        R.Rain(mi) = R.Rain(mi) + INT((TotalPrecip - ActualPrecip) * 100 + .5) / 100
END IF

EditRainFile R

END SUB

SUB MakeStageStorDisrel (pond AS pondtype)
REDIM a$(5)

IF pond.minstage = 0 THEN pond.minstage = VAL(GetLabel$("", "Input Stage at pond bottom (ft)"))
IF pond.MinStorage = 0 THEN pond.MinStorage = VAL(GetLabel$("", "Storage at this minimum stage (ac-ft)?"))
IF pond.invertstage = 0 THEN pond.invertstage = VAL(GetLabel$("", "Input Invert Stage (ft)"))
IF pond.numstordisrel = 0 THEN pond.numstordisrel = VAL(GetLabel$("", "How Many Relationships"))
IF pond.numstordisrel = 0 THEN EXIT SUB
IF pond.stageint = 0 THEN pond.stageint = VAL(GetLabel$("1", "Input Increment of Relationships (ft)"))
IF pond.stageint = 0 THEN EXIT SUB

WindowOpen 1, 4, 5, 8 + pond.numstordisrel, 75, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, ""

windowlocate 1, 4
windowprint -1, "Stage(ft)       Surface Area (acre) "
windowline 2

FOR i = 1 TO pond.numstordisrel
        windowlocate 2 + i, 6
        pond.stage(i) = pond.minstage + (i - 1) * pond.stageint
        windowprint -1, STR$(pond.stage(i))
        IF pond.srfarea(i) <> 0 THEN x$ = STR$(pond.srfarea(i)) ELSE x$ = ""
        EditFieldOpen i, x$, i + 2, 25, 14, 1, 10, 10
NEXT i

StorFlag = ControlEditWindow(pond.numstordisrel, 5 + pond.numstordisrel, help$)

FOR i = 1 TO pond.numstordisrel
        pond.srfarea(i) = VAL(EditFieldInquire(i))
NEXT i
pond.storage(1) = pond.MinStorage
FOR i = 2 TO pond.numstordisrel
        pond.storage(i) = pond.storage(i - 1) + (pond.srfarea(i) + pond.srfarea(i - 1)) / 2 * pond.stageint
NEXT i

WindowClose 1
getweirdischarge pond

END SUB

SUB PondRoute (activenode, pond AS pondtype, R AS RainfallType, n AS nodetype)
REDIM a$(2)
DIM BackTime!(10)
DIM BackStages!(10)
        

a$(1) = "No": a$(2) = "Yes"
BackWaterFlag = GetAnswer(2, a$(), "Do You Have a backwater relationship?")

IF BackWaterFlag = 2 THEN
        NumBackStages = VAL(GetLabel$("", "How Many Sets? (>3 and <10)"))
        FOR j = 1 TO NumBackStages
                BackTime!(j) = VAL(GetLabel$("", "Input Backwater Time " + STR$(j) + " (hr)"))
                BackStages!(j) = VAL(GetLabel$("", "Input #" + STR$(j) + " Backwater Stage (ft)"))
        NEXT j
END IF
IF pond.initstage = 0 THEN pond.initstage = pond.stage(1)
volume! = getVal!(pond.numstordisrel, pond.initstage, pond.stage(), pond.storage()) * 43560
IF volume! < 0 THEN volume! = 0

i = 1
pond.MaxVolume = 0
pond.MaxStage = 0
WHILE i < MAXSTEPS - 1
   LOCATE 5, 15
   PRINT 2, "Routing in Progress Step:" + STR$(i) + "   "

   FOR K = 1 TO 10
        pond.pstage(i) = getVal!(pond.numstordisrel, volume! / 43560!, pond.storage(), pond.stage())
        flow! = getVal!(pond.numstordisrel, volume! / 43560, pond.storage(), pond.discharge())
        IF flow! < 0 THEN flow! = 0
        
        IF BackWaterFlag = 2 THEN
                BackStage! = getVal!(NumBackStages, i * R.RainTimeStep / 60!, BackTime!(), BackStages!())
                unflow! = 0
                IF BackStage! > pond.pstage(i) THEN
                        flow! = 0
                ELSEIF BackStage! <> 0 AND pond.pstage(i) > BackStage! AND BackStage! > pond.initstage THEN
                        unflow! = getVal!(pond.numstordisrel, BackStage!, pond.stage(), pond.discharge())
                        'unflow! = pond.discharge(k) + (BackStage! - StartStage!) / (NextStage! - StartStage!) * ((pond.discharge(k + 1) - pond.discharge(k)))
                        IF unflow! < 0 THEN unflow! = 0
                        flow! = flow! - unflow!
                END IF
                IF flow! < 0 THEN flow! = 0
        END IF

        IF flow! < 0 THEN flow! = 0
                n.NodeOutflow(activenode, i) = flow!
                volume! = volume! + (n.NodeInflow(activenode, i) - n.NodeOutflow(activenode, i)) * R.RainTimeStep * 6
                IF volume! > pond.MaxVolume THEN pond.MaxVolume = volume!
                
                IF pond.pstage(i) > pond.MaxStage THEN pond.MaxStage = pond.pstage(i)
   NEXT K
                i = i + 1
WEND

FOR j = 1 TO MAXSTEPS - 1
        n.NodeInflow(n.FlowTo(activenode), j) = n.NodeOutflow(activenode, j) + n.NodeInflow(n.FlowTo(activenode), j)
        IF n.NodeOutflow(activenode, j) > peakpondflow! THEN peakpondflow! = n.NodeOutflow(activenode, j): pond.peakstep = j
NEXT j

colordisplay
END SUB

DEFSNG A-H, J-Y
SUB SantaBarbara (W AS WatershedType, H AS HydrographType, R AS RainfallType)

REDIM a$(100)

H.PeakOutflow = 0
H.TotalOutflow = 0
H.RUNOFF(1) = 0
H.Outflow(1) = 0
ExitFlag = FALSE
H.hydrotype = "Santa Barbara Method"

IF W.TimeCon = 0 THEN EXIT SUB
IF R.RainTimeStep = 0 THEN EXIT SUB


i = 1
H.KR = R.RainTimeStep / (2 * W.TimeCon + R.RainTimeStep)

WHILE NOT ExitFlag

        GetInfiltration i, W, H, R

        IF i >= 2 THEN
                H.Outflow(i) = H.Outflow(i - 1) + H.KR * (H.RUNOFF(i - 1) + H.RUNOFF(i) - 2 * H.Outflow(i - 1))
        ELSE
                H.Outflow(i) = H.KR * H.RUNOFF(i)
        END IF
        IF H.Outflow(i) > H.PeakOutflow THEN H.PeakOutflow = H.Outflow(i)

        IF i >= 5 THEN
                IF (H.Outflow(i) < .005 * H.PeakOutflow) OR (i = MAXSTEPS - 1) THEN
                        H.HydroSteps = i
                        ExitFlag = TRUE
                END IF
        END IF

        i = i + 1

WEND

END SUB

DEFINT J-L
SUB SCSMethod (W AS WatershedType, H AS HydrographType, R AS RainfallType)
STATIC UnitHydro()      AS SINGLE
DIM Response!(MAXSTEPS)
DIM currEditField       AS INTEGER
DIM currButton          AS INTEGER
REDIM UnitHydro(MAXSTEPS)    AS SINGLE
DIM Steptime                    AS SINGLE

UniformFlag = FALSE
IF H.PeakAttFact = -1 THEN UniformFlag = TRUE

IF W.TimeCon = 0 THEN EXIT SUB
IF R.RainTimeStep = 0 THEN EXIT SUB

FOR j = 1 TO H.HydroSteps
        H.Outflow(j) = 0
NEXT j

H.TotalOutflow = 0
H.PeakOutflow = 0
IF H.PeakAttFact = 0 THEN

REDIM a$(17)

        a$(1) = "You must choose a value for the Peak Attenuation Factor."
        a$(2) = "   RL = Recession Limb Time    TP = Time to Peak"
        a$(3) = ""
        a$(4) = "645: Rational Hydrograph , Steep Terrain"
        a$(5) = "Note that Rain Duration must = Time of Concentration"
        a$(6) = "580: RL = 1.25 * TP"
        a$(7) = "484: RL = 1.67 * TP, Typical SCS Curve"
        a$(8) = "400: RL = 2.25 * TP"
        a$(9) = "300: RL = 3.33 * TP, Minimum Slope ,Urban"
        a$(10) = "200: RL = 5.50 * TP"
        a$(11) = "100: RL = 12.0 * TP, Rural, Flat Terrain"
         a$(12) = ""
         a$(13) = "50 < K < 646"

WindowOpen 1, 3, 5, 19, 75, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, "Attenuation"

FOR i = 1 TO 13
        windowlocate i, 5
        windowprint 1, a$(i)
NEXT i

EditFieldOpen 1, "", 17, 20, 14, 1, 5, 5

ButtonOpen 1, 1, "Cancel", 17, 40, 19, 50, 1

ExitFlag = FALSE
currButton = 0
currEditField = 1

WHILE NOT ExitFlag
        WindowDo currButton, currEditField
        SELECT CASE Dialog(0)
        CASE 1:
                WindowClose 1
                EXIT SUB
        CASE 2: currEditField = 1
        CASE 6
                IF ButtonInquire(1) = 2 THEN
                        WindowClose 1
                        EXIT SUB
                END IF
                IF EditFieldInquire(1) <> "" THEN ExitFlag = TRUE
        CASE 7
                ButtonToggle 1
                IF ButtonInquire(1) = 2 THEN currEditField = 0 ELSE currEditField = 1
        CASE 9
                WindowClose 1
                EXIT SUB
        END SELECT
WEND
H.PeakAttFact = VAL(EditFieldInquire(1))
WindowClose 1
IF H.PeakAttFact < 50 OR H.PeakAttFact > 1000 THEN
        a$ = "Illegal Value of Attenuation"
        junk = Alert(4, a$, 9, 10, 12, 70, "", "", "")
        EXIT SUB
END IF


ELSE
END IF
IF UniformFlag = TRUE THEN EXIT SUB

' ===========  Generate Unit Hydrograph ===============

FallLimbFact = (1291 / H.PeakAttFact) - 1


IF W.TimeCon < R.RainTimeStep THEN
        UnitTimeCon = R.RainTimeStep
ELSE
        UnitTimeCon = W.TimeCon
END IF

TimeFall = FallLimbFact * W.TimeCon
TotalUnitTime = UnitTimeCon + TimeFall
TotalUnitTime = INT(TotalUnitTime / R.RainTimeStep + .5) * R.RainTimeStep
JSteps = INT(TotalUnitTime / R.RainTimeStep + .5)

IF W.SmoothFlag = FALSE THEN
        FOR j = 1 TO JSteps
                Steptime = j * R.RainTimeStep
                IF Steptime <= UnitTimeCon THEN
                        UnitHydro(j) = Steptime / UnitTimeCon
                        tp = j
                ELSE
                        UnitHydro(j) = 1 + UnitTimeCon / TimeFall - Steptime / TimeFall
                END IF
        NEXT j
END IF

IF W.SmoothFlag = TRUE THEN
        FOR j = 1 TO JSteps
                Steptime = j * R.RainTimeStep
                tr! = Steptime / UnitTimeCon
                IF Steptime <= UnitTimeCon THEN
                        UnitHydro(j) = .05903 - .7650173 * tr! + 4.415467 * tr! ^ 2 - 2.708 * tr! ^ 3
                        tp = j
                ELSE
                        IF H.PeakAttFact = 484 THEN a! = 2.445061: b! = -1.763459: c! = .425012: c! = .425012: D! = -.034003
                        IF H.PeakAttFact = 256 THEN a! = 1.883346: b! = -.9724275: c! = .1670826: D! = -.009394733#
                        UnitHydro(j) = a! + b! * tr! + c! * tr! ^ 2 + D! * tr! ^ 3
                END IF
        IF UnitHydro(j) < 0 THEN UnitHydro(j) = 0
        NEXT j
END IF

TotalHydro = 0
FOR j = 1 TO JSteps
        TotalHydro = TotalHydro + UnitHydro(j)
NEXT j


FOR j = 1 TO JSteps
        UnitHydro(j) = UnitHydro(j) / TotalHydro
        IF UnitHydro(j) > p! THEN p! = UnitHydro(j)
NEXT j

' ==========   Generate Hydrograph using unit Hydrograph ===============

i = 1
ExitFlag = FALSE
WHILE NOT ExitFlag
        GetInfiltration i, W, H, R
        FOR j = 0 TO i - 1
                H.Outflow(i) = H.Outflow(i) + H.RUNOFF(i - j) * UnitHydro(j + 1)
        NEXT j

        IF H.Outflow(i) > H.PeakOutflow THEN H.PeakOutflow = H.Outflow(i)
        
        IF i = MAXSTEPS THEN ExitFlag = TRUE
        IF i > 5 AND H.Outflow(i) < .005 * H.PeakOutflow THEN ExitFlag = TRUE
        
        i = i + 1
WEND
H.HydroSteps = i
IF H.HydroSteps > MAXSTEPS THEN H.HydroSteps = MAXSTEPS - 1
END SUB

DEFSNG I-L
SUB SetupDesktop STATIC

    MouseHide

    WIDTH , 25
    COLOR 15, 1      'Color
    CLS

    FOR a = 2 TO 80 STEP 4
        FOR b = 2 TO 25 STEP 2
            LOCATE b, a
            PRINT CHR$(250);
        NEXT b
    NEXT a
'    LOCATE 20, 10: PRINT "Remaining Stack Space "; FRE(-2)
'    LOCATE 21, 10: PRINT "Remaining Memory Space "; FRE(-1)

    LOCATE 25, 1
    COLOR 0, 7: PRINT STRING$(80, " ");
    LOCATE 25, 1
    IF HydroFile$ <> "" THEN PRINT "Current Hydrograph :"; HydroFile$; "  ";

    MouseShow
END SUB

DEFINT A-Z
SUB SetupMenu

    MenuSet 1, 0, 1, "Utilities", 1
    MenuSet 1, 1, 1, "Use HELP Utility           F1", 5
    MenuSet 1, 2, 1, "Change Current Directory   F2", 1
    MenuSet 1, 3, 1, "Send Form Feed to Printer  F3", 6
    MenuSet 1, 4, 1, "-", 1
    MenuSet 1, 5, 1, "Exit                   Ctrl-X", 2
                          
    MenuSet 2, 0, 1, "Watershed", 1
    MenuSet 2, 1, 1, "Create Watershed File", 1
    MenuSet 2, 2, 1, "Edit/View Watershed File", 1
    MenuSet 2, 3, 1, "Retrieve Watershed File", 1
    MenuSet 2, 4, 1, "Save Watershed File", 1
    MenuSet 2, 5, 1, "Delete Watershed File", 1
    MenuSet 2, 6, 1, "Print Current Watershed", 1

    MenuSet 3, 0, 1, "Rainfall", 1
    MenuSet 3, 1, 1, "Create RainFall File", 1
    MenuSet 3, 2, 1, "Edit/View Rainfall File", 1
    MenuSet 3, 3, 1, "Retrieve Rainfall File", 1
    MenuSet 3, 4, 1, "Save Rainfall File", 1
    MenuSet 3, 5, 1, "Delete a Rainfall File", 1
    MenuSet 3, 6, 1, "Use Dimensionless Curves", 1
    MenuSet 3, 7, 1, "Print Rainfall File", 1

    MenuSet 4, 0, 1, "Hydrograph", 1
    MenuSet 4, 1, 1, "Generate Hydrograph", 7
    MenuSet 4, 2, 1, "View Hydrograph", 1
    MenuSet 4, 3, 1, "Retrieve Hydrograph", 1
    MenuSet 4, 4, 1, "Save Hydrograph", 1
    MenuSet 4, 5, 1, "Plot Hydrograph", 3
    MenuSet 4, 6, 1, "Print Hydrograph", 1

    MenuSet 5, 0, 1, "Pond", 1
    MenuSet 5, 1, 1, "Create Pond relationship", 1
    MenuSet 5, 2, 1, "Edit Stage Storage Discharge", 1
    MenuSet 5, 3, 1, "Retrieve Pond Relationship", 1
    MenuSet 5, 4, 1, "Save Pond Relationship", 1

    MenuSet 6, 0, 1, "Routing", 4
    MenuSet 6, 1, 1, "Define Node and Type", 1
    MenuSet 6, 2, 1, "Link Defined Nodes", 1
    MenuSet 6, 3, 1, "Output Batch Data File", 8
    MenuSet 6, 4, 1, "Display Defined Nodes", 3
    MenuSet 6, 5, 1, "Plot Defined Nodes", 3
    MenuSet 6, 6, 1, "Print Nodal Analysis", 1
    MenuSet 6, 7, 1, "View Active Node", 1
    MenuSet 6, 8, 1, "Unlink a Node", 1
    MenuSet 6, 8, 1, "Unlink All Nodes", 1

    MenuSet 7, 0, 1, "Order", 1
    MenuSet 7, 1, 1, "Print Order Form", 1
    MenuSet 7, 2, 1, "About Programs  ", 1

    ShortCutKeySet 1, 1, CHR$(0) + CHR$(59) ' F1
    ShortCutKeySet 1, 2, CHR$(0) + CHR$(60) ' F2
    ShortCutKeySet 1, 3, CHR$(0) + CHR$(61) ' F3

    ShortCutKeySet 1, 6, CHR$(24)          ' Ctrl-X

    IF NOT DisplayType THEN
        MenuColor 0, 7, 15, 8, 7, 0, 15   'Best for monochrome and colors
    ELSE
        MenuColor 0, 7, 4, 8, 15, 0, 12   'Best for color
    END IF

    MenuPreProcess

END SUB

DEFSNG A-Z
SUB ShedCalc (W AS WatershedType)

IF W.DCIA <> 0 THEN W.FracDCIA = (W.ImpArea / W.TotalArea) * (W.DCIA / 100)
IF W.TotalArea <> 0 THEN
        W.FracNDCIA = (W.ImpArea / W.TotalArea) * ((100 - W.DCIA) / 100)
        W.FracPerv = (W.TotalArea - W.ImpArea) / W.TotalArea
END IF
END SUB

DEFINT A-Y
FUNCTION truncate$ (vari AS SINGLE, places AS INTEGER)
vari2! = vari * (10 ^ places) + .5
vari2! = INT(vari2!)
vari2! = vari2! / (10 ^ places)
truncate$ = STR$(vari2!)

END FUNCTION

SUB UnlinkAllNodes (n AS nodetype)

FOR activenode = 1 TO MAXNODES
    IF n.FlowTo(activenode) <> 0 THEN
        FOR i = 1 TO MAXSTEPS: n.NodeInflow(n.FlowTo(activenode), i) = n.NodeInflow(n.FlowTo(activenode), i) - n.NodeOutflow(activenode, i): n.NodeOutflow(activenode, i) = 0: NEXT i
        n.FlowTo(activenode) = 0
    END IF
NEXT activenode
END SUB

SUB UnlinkNode (n AS nodetype)
activenode = GetNode("Unlink what Node?", FALSE, FALSE, n)
IF activenode = 0 OR n.FlowTo(activenode) = 0 THEN EXIT SUB
FOR i = 1 TO MAXSTEPS: n.NodeInflow(n.FlowTo(activenode), i) = n.NodeInflow(n.FlowTo(activenode), i) - n.NodeOutflow(activenode, i): n.NodeOutflow(activenode, i) = 0: NEXT i
n.FlowTo(activenode) = 0
END SUB

SUB ViewHydrograph (NodeFlag, STEPS, p() AS pondtype, H AS HydrographType, R AS RainfallType, n AS nodetype)

IF NodeFlag = FALSE AND H.HydroSteps = 0 THEN
        a$ = "No Hydrograph is currently active in memory, either retrieve|"
        a$ = a$ + "a hydrograph from disk or generate one."
        junk = Alert(4, a$, 9, 10, 14, 70, "", "", "")
        EXIT SUB
END IF
IF NodeFlag = TRUE THEN
        ContinueFlag = FALSE
        FOR i = 1 TO MAXNODES
                IF n.NodeExist(i) = TRUE THEN ContinueFlag = TRUE
        NEXT i
        IF ContinueFlag = FALSE THEN
                a1$ = "There are no nodes defined. To save data you first"
                a1$ = a1$ + "|must define and link your nodes."
                junk = Alert(4, a1$, 10, 10, 16, 70, "", "Continue", "")
                EXIT SUB
        END IF
END IF
IF NodeFlag = (TRUE) THEN
        activenode = GetNode("Choose Node to View", FALSE, FALSE, n)
        IF activenode = 0 THEN EXIT SUB
END IF

WindowOpen 1, 3, 2, 23, 75, 14, 1, 14, 1, 15, FALSE, TRUE, FALSE, TRUE, 2, "HYDROGRAPH"
IF NodeFlag = FALSE THEN DrawHydrograph 0, H, R
IF NodeFlag = TRUE THEN DrawNode 0, p(), R, n
MenuOff
ButtonOpen 1, 1, "", 4, 72, 18, 72, 6
Position = 1
ExitFlag = FALSE
currButton = 1
currstate = 1

WHILE NOT ExitFlag
WindowDo currButton, 0
x = Dialog(0)
Position = (currstate - 1) * 8

SELECT CASE x
        CASE 1
                Scrollcode = Dialog(19)
        CASE 4, 9
                WindowClose 1
                MenuOn
                EXIT SUB
        CASE 10
                Scrollcode = -1
        CASE 11
                Scrollcode = -2
        CASE ELSE
                Scrollcode = Dialog(19)
        END SELECT


SELECT CASE Scrollcode
        CASE -1
                IF currstate > 1 THEN currstate = currstate - 1
        CASE -2
                IF currstate < 13 THEN currstate = currstate + 1
        CASE ELSE
                currstate = Scrollcode
END SELECT
IF currstate < 1 THEN currstate = 1
Position = (currstate - 1) * 12
IF NodeFlag = FALSE THEN DrawHydrograph Position, H, R
IF NodeFlag = TRUE THEN DrawNode Position, p(), R, n
ButtonSetState 1, currstate
WEND
MenuOn
END SUB

