'$INCLUDE: 'cmndlg.bi'
'$INCLUDE: 'SM_type.BI'
'$INCLUDE: 'SM_int.BI'
'$INCLUDE: 'SM_calc.bi'

Const MAXNODES = 8
Const MAXUNIT = 100
Const MAXSTEPS = 260
Const SSD_RELATIONSHIPS = 20

Const OSCREEN = 0
Const OPRINTER = 1
Const OFILE = 2

Const VNOTCH60 = 0
Const VNOTCH90 = 1
Const SCRECT = 2
Const BCRECT = 3
Const ORIFICE = 4

'Infiltration Types

Const SCS_INFILTRATION = 100
Const HORTON_INFILTRATION = 101

' Types of Rainfall

Const USER_RAINFALL = 100
Const SCSTYPEII_RAINFALL = 101
Const SCSTYPEIIFL_RAINFALL = 102
Const SCSTYPEIII_RAINFALL = 103
Const CONSTANT_RAINFALL = 104

Sub DeleteFile (FileType As Integer)
Dim Cancel           As Integer
Dim Success          As Integer
Dim FullName         As String

Select Case FileType
    Case 1  'Watershed
       Ext$ = "*.shd"
       TT$ = "Watershed"
    Case 2  'Rainfall
       Ext$ = "*.rnf"
       TT$ = "Rainfall"
    Case 3  ' Hydrograph
       Ext$ = "*.hyd"
       TT$ = "Hydrograph"
    Case 4  ' Pond
       Ext$ = "*.pnd"
       TT$ = "Pond"

End Select

'FileOpen FileName$, PathName$, Ext$, "Delete " + TT$ + " File", 0, 7, 0, Cancel
If Cancel Then Exit Sub
FullName = PathName$ + "\" + FileName$
Kill FullName
MsgBox (FullName + " Deleted")
End Sub

Function Formt$ (var As Single, CurForm As String, n As Integer)
   d$ = Format$(var, CurForm)
   If Len(d$) < n Then
      Formt$ = String$(n - Len(d$), " ") + d$
   ElseIf Len(d$) > n Then
      Formt$ = Left$(d$, n)
   Else
      Formt$ = d$
   End If
End Function

Sub GenerateHydrograph (HydType As Integer)
    If r.numbersteps = 0 Then
       MsgBox ("There is No Rainfall File")
       Exit Sub
    End If

    If w.TotalArea = 0 Or w.InfMeth = 0 Then
       MsgBox ("There is No Watershed File")
       Exit Sub
    End If

    GenerateInstantHydrograph w, r, h
    ' h.runoff(1)
Select Case HydType
    Case 1: GenerateSantaBarbara h
    Case 2: GenerateSCSMethod 0, h
    Case 3: GenerateSCSMethod 484, h
    Case 4: GenerateSCSMethod 256, h
    Case 5
       If uh.numbersteps = 0 Then
          MsgBox ("No Unit Hydrograph in Memory")
          Exit Sub
       End If
       h.hydrotype = "Unit Generated Hydrograph"
       GenerateUnitHydrograph uh, h
End Select
End Sub

Sub GenerateRainfall (Tr As RainfallType)
    If Tr.Type = USER_RAINFALL Then
       Exit Sub
    Else
       MakeDimRainFall r
    End If
End Sub

Function NewFile% (NF As Integer)
    NewFile% = False
    Select Case NF
       Case 1
          If MsgBox("All Watershed Information Will Be Erased!, Continue?", 4, "New Watershed") = 6 Then
             NewShedFile w
             NewFile% = True
          End If
       Case 2
          If MsgBox("All Rainfall Information Will Be Erased!, Continue?", 4, "New Rainfall") = 6 Then
             NewRainfall r
             NewFile% = True
          End If
      Case 3
          If MsgBox("All Hydrograph Information Will Be Erased!, Continue?", 4, "New Rainfall") = 6 Then
             NewHydrograph h
             NewFile% = True
          End If
      
      Case 4
          If MsgBox("All Pond Information Will Be Erased!, Continue?", 4, "New Rainfall") = 6 Then
             NewPondFile p
             NewFile% = True
          End If
    End Select
End Function

Function OpenOutput% ()

   On Local Error GoTo OpenOutputError
   Open ODest For Output As #1
   OpenOutput% = True
Exit Function

OpenOutputError:
   Close
   OpenOutput% = False
   Exit Function
   
End Function

Sub PlaceExtension (FileName As String, Ext As String)
Dim ploc        As Integer
Dim slen        As Integer

ploc = InStr(FileName, ".")
If ploc = 0 Then
'   slen = Len(FileName)
'   If slen > 8 Then FileName = Left$(FileName, 8)
   FileName = FileName + "." + Ext
End If
End Sub

Function PrintHydrograph$ (TH As HydrographType, Tr As RainfallType, page As Integer)
Dim i           As Integer
Dim j           As Integer
Dim CumInf      As Single
Dim CumRain     As Single
Dim rs          As String
If TH.TotalArea = 0 Then Exit Function

CumRain = 0

rs = ""

rs = rs + Label$ + "    Hydrograph Type :" + TH.hydrotype + "~"
rs = rs + String$(60, "-") + "~"
rs = rs + "Time   Rain  C Rain Infiltration Instant  Outflow~"
rs = rs + "(hr)   (in)   (in)      (in)      (cfs)    (cfs)~"
rs = rs + String$(60, "-") + "~"


TH.TotalRunoff = 0
TH.TotalOutflow = 0
For j = 1 To TH.hydrosteps
    CumRain = CumRain + Tr.rain(j)
    CumInf = CumInf + TH.infiltration(j)
    TH.TotalRunoff = TH.TotalRunoff + TH.runoff(j) * Tr.timestep * 60
    TH.TotalOutflow = TH.TotalOutflow + TH.outflow(j) * Tr.timestep * 60

    rs = rs + Formt$(j * Tr.timestep / 60, "#0.00", 4)
    rs = rs + Formt$(Tr.rain(j), "  0.00", 6)
    rs = rs + Formt$(CumRain, "   #0.00", 8)
    rs = rs + Formt$(TH.infiltration(j), "     #0.00", 10)
    rs = rs + Formt$(TH.runoff(j), "  ####0.00", 10)
    rs = rs + Formt$(TH.outflow(j), "   ####0.00", 11) + "~"
Next j

rs = rs + String$(60, "-") + "~"


rs = rs + "              "
rs = rs + Formt$(CumRain, "#0.00   ", 8)
rs = rs + Formt$(CumInf, "  #0.00   ", 10)
rs = rs + Formt$((12 * TH.TotalRunoff / (TH.TotalArea * 43560)), "  #0.00", 8)
rs = rs + Formt$((12 * TH.TotalOutflow / (TH.TotalArea * 43560)), "      #0.00", 10) + "~"
rs = rs + "      Totals for Watershed in inches over " + Format$(TH.TotalArea, "###0.00") + " acres~"
               
If CumRain <> 0 Then TH.RatCoeff = (CumRain - CumInf) / CumRain

rs = rs + "Rational Coefficient = " + Format$(TH.RatCoeff, "0.000")
rs = rs + "   Peak Flow (cfs) = " + Format$(TH.PeakOutflow, "##00.00") + "~"
                
                'print #1, Tab(9);
                If Left$(TH.hydrotype, 5) = "Santa" Then
                        'print #1, USING "Routing Coefficient    = #.###"; TH.KR
                Else
                        'print #1, USING "Peak Attenuation Factor = ###"; TH.PeakAttFact
                End If

PrintHydrograph$ = rs
End Function

Function PrintPondDesign$ (TP As PondType)
Dim i       As Integer

      rs$ = "Stage    Storage   Weir 1 Q   Weir 2 Q  Discharge~"
rs$ = rs$ + "(ft)     (ac-ft)     (cfs)      (cfs)     (cfs)~"
rs$ = rs$ + String$(60, "-") + "~"


For i = 1 To TP.NumberSSD
rs$ = rs$ + Formt$(TP.Stage(i), "###0.00", 7) + Formt$(TP.Storage(i), "   ##0.00", 9)
rs$ = rs$ + Formt$(TP.Weir(1).Discharge(i), "    ###0.00", 12)
rs$ = rs$ + Formt$(TP.Weir(2).Discharge(i), "   ###0.00", 10)
rs$ = rs$ + Formt$(TP.Discharge(i), "   ###0.00", 10) + "~"
Next i
rs$ = rs$ + "~"

For i = 1 To TP.NumberWeirs
   rs$ = rs$ + "        Weir Number" + Format$(i, "0") + "~"
   rs$ = rs$ + " Type       : " + TP.Weir(i).Label + "~"
   rs$ = rs$ + " Equation   : " + TP.Weir(i).Equation + "~"
   rs$ = rs$ + " Weir Invert (ft)   : " + Formt$(TP.Weir(i).Invert, "###0.00", 7) + "~"
   rs$ = rs$ + "  C:" + Formt$(TP.Weir(i).C, "#0.00", 5)
   rs$ = rs$ + "  n:" + Formt$(TP.Weir(i).n, "#0.00", 5) + "~"
   If TP.Weir(i).Type = SCRECT Or TP.Weir(i).Type = BCRECT Then
      rs$ = rs$ + " Base Width  (ft)   : " + Formt$(TP.Weir(i).Width, "##0.00", 6) + "~"
   ElseIf TP.Weir(i).Type = ORIFICE Then
      rs$ = rs$ + " Orifice Diameter (ft)   : " + Formt$(TP.Weir(i).Diameter, "##0.00", 6) + "~"
   End If
Next i

PrintPondDesign$ = rs$
End Function

Function PrintPondRouting$ (TP As PondType)
Dim i       As Integer

      rs$ = "  Time    Inflow     Outflow      Stage~"
rs$ = rs$ + "  (hr)     (cfs)      (cfs)        (ft)~"
rs$ = rs$ + String$(60, "-") + "~"

For i = 1 To TP.numbersteps
   rs$ = rs$ + Formt$(TP.timestep * i / 60, " ##0.00", 7)
   rs$ = rs$ + Formt$(TP.Inflow(i), "   ###0.00", 10)
   rs$ = rs$ + Formt$(TP.outflow(i), "   ###0.00", 10)
   rs$ = rs$ + Formt$(TP.pStage(i), "      ###0.00", 13) + "~"
Next i

PrintPondRouting$ = rs$
End Function

Function PrintRainfall$ (Tr As RainfallType)
Dim i           As Integer
Dim j           As Integer

Dim CumRain     As Single
Dim rs          As String


CumRain = 0

rs = ""


rs = rs + String$(40, "-") + "~"
rs = rs + "Time   Rain  Cumulative ~"
rs = rs + "(hr)   (in)     (in)  ~"
rs = rs + String$(40, "-") + "~"


For j = 1 To Tr.numbersteps
    CumRain = CumRain + Tr.rain(j)




    rs = rs + Formt$(j * Tr.timestep / 60, "#0.00", 4)
    rs = rs + Formt$(Tr.rain(j), "  0.00", 6)
    rs = rs + Formt$(CumRain, "   #0.00", 8) + "~"
Next j

rs = rs + String$(40, "-") + "~"


rs = rs + "              "
rs = rs + Formt$(CumRain, "#0.00   ", 8) + "~"
               
PrintRainfall$ = rs

End Function

Function PrintWatershed$ (TW As WatershedType)
Dim rs  As String

rs = String$(5, " ") + "  SMADA 5.0 Unregistered DOS Version~"
rs = rs + String$(9, " ") + "  Watershed Information~~"
rs = rs + "Watershed Total Area (acres)     :" + Format$(TW.TotalArea, "####0.00") + "~"
rs = rs + "Impervious Area (acres)          :" + Format$(TW.ImpArea, "####0.00") + "~"
rs = rs + "Time of Concentration (min)      :" + Format$(TW.TimeCon, "##0.0") + "~"
rs = rs + "% Impervious Directly Connected  :" + Format$(TW.DCIA, "00.00") + "~~"

rs = rs + String$(5, " ") + "Additional Abstraction~"
rs = rs + "Over Pervious Area (inches)      :" + Format$(TW.addabsPerv, "#0.00") + "~"
rs = rs + "Over Impervious Area (inches)    :" + Format$(TW.AddAbsImp, "#0.00") + "~~"
rs = rs + "Infiltration Characteristics: " + TW.Label + "~"
rs = rs + "Max Infiltration Capacity (in)   :" + Format$(TW.MaxInf, "##0.00") + "~"

If TW.InfMeth = SCS_INFILTRATION Then
rs = rs + "SCS Curve Number for Pervious    :" + Format$(TW.CN, "#00") + "~"
rs = rs + "Initial Abstraction Factor       :" + Format$(TW.InitAbs, "0.00") + "~"
ElseIf TW.InfMeth = HORTON_INFILTRATION Then
rs = rs + "Horton Initial Rate (in/hr)      :" + Format$(TW.HIO, "##0.00") + "~"
rs = rs + "Horton Limiting Rate (in/hr)     :" + Format$(TW.HIC, "##0.00") + "~"
rs = rs + "Depletion Coefficient (/hr)      :" + Format$(TW.HK, "#0.000") + "~"
End If
PrintWatershed$ = rs
End Function

Sub RouteFile (sn As Integer, dn As Integer)
   If sn = 0 And dn = 0 Then
      If h.hydrosteps = 0 Then
         MsgBox ("Must Have a Hydrograph to Perform a Quick Route")
         Exit Sub
      End If

      If p.NumberSSD = 0 Then
         MsgBox ("Must have a Pond to Perform a Quick Route")
         Exit Sub
      End If

      RouteHYDRtoPOND h, p

      MsgBox ("Current Hydrograph Routed to Current Pond")

   End If
End Sub

Sub ViewWatershed (TW As WatershedType)


End Sub

