REM
'$INCLUDE: 'smada.bi'
'$INCLUDE: 'general.bi'
'$INCLUDE: 'mouse.bi'
'$INCLUDE: 'menu.bi'
'$INCLUDE: 'window.bi'

DECLARE FUNCTION ControlEditWindow% (EditFields%, ButtonLine%, h$)
DECLARE FUNCTION GetLabel$ (default$, Message$)
DECLARE FUNCTION GetValue! (a!, Message$)


DECLARE SUB ShedCalc (w AS watershedtype)
DECLARE SUB SaveStorDisrel (pond AS pondtype)
DECLARE SUB EditRainFile (r AS rainfalltype)
DECLARE SUB EditShedFile (w AS watershedtype)

DEFINT A-Z
SUB CreateRainFile (r AS rainfalltype)
StartofCreateRainFile:
WindowOpen 1, 6, 5, 12, 75, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, "CREATE RAINFALL ARRAY"

windowlocate 2, 2
windowprint 2, "Time step of Rainfall Increments (minutes):"
windowlocate 4, 2
windowprint 2, "Total Duration of Rainfall event (hours):"

EditFieldOpen 1, "", 2, 50, 14, 1, 10, 10
EditFieldOpen 2, "", 4, 50, 14, 1, 10, 10

IF ControlEditWindow(2, 7, help$) = FALSE THEN EXIT SUB

r.RainTimeStep = VAL(EditFieldInquire(1))
r.RainDuration = VAL(EditFieldInquire(2))

IF r.RainTimeStep <> 0 THEN r.NumRainSteps = r.RainDuration * 60 / r.RainTimeStep + .5
WindowClose 1

FOR i = 1 TO MAXSTEPS
        r.Rain(i) = 0
NEXT i
IF r.RainTimeStep = 0 THEN
        a$ = "Your time step for rainfall must be greater than 0."
        a$ = a$ + "|Please correct before continuing."
        junk = Alert(4, a$, 7, 9, 12, 69, "", "Continue", "")
        GOTO StartofCreateRainFile
END IF

IF r.RainDuration = 0 THEN
        a$ = "Your rainfall duration must be greater than 0."
        a$ = a$ + "|Please correct before continuing."
        junk = Alert(4, a$, 7, 9, 12, 69, "", "Continue", "")
        GOTO StartofCreateRainFile
END IF

IF r.NumRainSteps > 96 THEN
        a$ = "You have exceeded 96 Rainfall increments.|"
        a$ = a$ + "Please increase Time Step or reduce Duration."
        junk = Alert(4, a$, 7, 9, 12, 69, "", "Continue", "")
        GOTO StartofCreateRainFile
END IF

IF r.DimFlag <> 1 THEN
        EditRainFile r
END IF

END SUB

SUB CreateShedFile (w AS watershedtype)

a$ = "You Must Choose a method for the prediction of infiltration.|"
a$ = a$ + "The methods available are the Horton Infiltration method and|"
a$ = a$ + "the SCS - Curve Number Method"

w.InfMeth = Alert(4, a$, 6, 5, 10, 75, "Cancel", "Horton", "SCS-CN")

IF w.InfMeth = 1 THEN
        w.InfMeth = 0
        EXIT SUB
ELSE
        EditShedFile w
END IF

END SUB

SUB EditRainFile (r AS rainfalltype)
REDIM a$(97)

MenuOff

IF r.RainTimeStep = 0 THEN
        a$ = "You must create or retrieve a rainfall before editing"
        a$ = a$ + "|use Create, Retrieve, or Use Dimensionless curves"
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        EXIT SUB
END IF


r.TotalRain = 0
FOR i = 1 TO r.NumRainSteps
        IF r.Rain(i) <> 0 THEN a$(i) = STR$(r.Rain(i)) ELSE a$(i) = ""
        r.TotalRain = r.TotalRain + r.Rain(i)
NEXT i

WindowOpen 1, 3, 3, 24, 75, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, "Rainfall Edit"

        windowlocate 1, 1
        windowprint 2, "Time  Rain  Time  Rain   Time  Rain   Time  Rain   Time  Rain  Time  Rain"
        windowlocate 2, 1
        windowprint 2, "min   inch   min  inch   min   inch   min   inch   min   inch  min   inch"

FOR i = 1 TO r.NumRainSteps
        RainTime = RaintTime + i * r.RainTimeStep
        RainTime$ = LTRIM$(STR$(RainTime))
        GOSUB getpos
        windowlocate posy, posx
        windowprint 2, RainTime$
        windowlocate posy, posx + 5
        windowprint -1, a$(i)
NEXT i

        ButtonOpen 1, 1, "Complete", 22, 59, 0, 0, 1
        windowlocate 22, 30
        windowprint -1, "Total Rain"
        ExitFlag = FALSE
        i = 1
        GOSUB getpos
        EditFieldOpen 1, STR$(r.Rain(i)), posy, posx + 5, 14, 1, 5, 5


WHILE NOT ExitFlag
        r.TotalRain = CSNG(CINT(r.TotalRain * 100) / 100)
        windowlocate 22, 42
        windowprint -1, STR$(r.TotalRain) + " in     "
        WindowDo currButton, 1
        SELECT CASE Dialog(0)
               
                CASE 1, 9
                        ExitFlag = TRUE
                CASE 10
                        IF i > 1 THEN j = -1 ELSE j = 0
                        GOSUB newpos
                CASE 11, 6
                        IF i < r.NumRainSteps THEN j = 1 ELSE j = 0: ExitFlag = TRUE
                        GOSUB newpos
        END SELECT
        WEND

lrain! = r.Rain(i)
r.Rain(i) = VAL(EditFieldInquire(1))
r.TotalRain = r.TotalRain + r.Rain(i) - lrain!

WindowClose 1

EXIT SUB
getpos:
        IF i < 20 THEN posy = i + 2: posx = 1
        IF i >= 20 AND i < 39 THEN posy = i - 17: posx = 14
        IF i >= 39 AND i < 58 THEN posy = i - 36: posx = 27
        IF i >= 58 AND i < 77 THEN posy = i - 55: posx = 40
        IF i >= 77 AND i < 96 THEN posy = i - 74: posx = 53
        IF i >= 96 THEN posy = i - 93: posx = 64
RETURN
newpos:
        lrain! = r.Rain(i)
        r.Rain(i) = VAL(EditFieldInquire(1))
        EditFieldClose 1
        r.TotalRain = r.TotalRain + r.Rain(i) - lrain!
        GOSUB getpos
        windowlocate posy, posx + 5
        IF r.Rain(i) = 0 THEN a$(i) = "" ELSE a$(i) = STR$(r.Rain(i))
        windowprint -1, a$(i)
        i = i + j
        GOSUB getpos
        IF r.Rain(i) = 0 THEN a$(i) = "" ELSE a$(i) = STR$(r.Rain(i))
        EditFieldOpen 1, a$(i), posy, posx + 5, 14, 1, 5, 5
RETURN
END SUB

SUB EditShedFile (w AS watershedtype)
REDIM a$(10)
MenuOff

IF w.InfMeth = 0 THEN
        a$ = "You must create or retrieve a watershed before editing"
        a$ = a$ + "|Use Create or Retrieve Watershed"
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        EXIT SUB
END IF

StartofEditShedFile:

IF w.TotalArea <> 0 THEN a$(1) = STR$(w.TotalArea) ELSE a$(1) = ""
IF w.TimeCon <> 0 THEN a$(2) = STR$(w.TimeCon) ELSE a$(2) = ""
IF w.ImpArea <> 0 THEN a$(3) = STR$(w.ImpArea) ELSE a$(3) = ""
IF w.DCIA <> 0 THEN a$(4) = STR$(w.DCIA) ELSE a$(4) = ""
IF w.AddAbsImp <> 0 THEN a$(5) = STR$(w.AddAbsImp) ELSE a$(5) = ""
IF w.addabsPerv <> 0 THEN a$(6) = STR$(w.addabsPerv) ELSE a$(6) = ""
IF w.MaxInf <> 0 THEN a$(7) = STR$(w.MaxInf) ELSE a$(7) = ""

WindowOpen 1, 5, 5, 18, 75, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, "Watershed Edit"

windowlocate 1, 5
windowprint 1, "Drainage area (acres)"
EditFieldOpen 1, a$(1), 1, 55, 14, 1, 10, 10
windowlocate 2, 5
windowprint 1, "Time of Concentration (min)"
EditFieldOpen 2, a$(2), 2, 55, 14, 1, 10, 10
windowlocate 3, 5
windowprint 1, "Impervious Watershed Area (acres)"
EditFieldOpen 3, a$(3), 3, 55, 14, 1, 10, 10
windowlocate 4, 5
windowprint 1, "Percent of Impervious Directly Connected (%)"
EditFieldOpen 4, a$(4), 4, 55, 14, 1, 10, 10
windowlocate 5, 5
windowprint 1, "Additional Abstraction for Impervious Area (in)"
EditFieldOpen 5, a$(5), 5, 55, 14, 1, 10, 10
windowlocate 6, 5
windowprint 1, "Additional Abstraction for Pervious Area (in)"
EditFieldOpen 6, a$(6), 6, 55, 14, 1, 10, 10
windowlocate 7, 5
windowprint 1, "Maximum Infiltration Capacity (in)"
EditFieldOpen 7, a$(7), 8, 55, 14, 1, 10, 10
windowlocate 8, 5
windowprint 1, "Input 999 if No Limit Exists"

IF w.InfMeth = 2 THEN
        IF w.HIC <> 0 THEN a$(8) = STR$(w.HIC) ELSE a$(8) = ""
        IF w.HIO <> 0 THEN a$(9) = STR$(w.HIO) ELSE a$(9) = ""
        IF w.HK <> 0 THEN a$(10) = STR$(w.HK) ELSE a$(10) = ""
        MaxField = 10
        windowlocate 10, 5
        windowprint 1, "Limiting Infiltration Rate (in/hr)"
        EditFieldOpen 8, a$(8), 10, 55, 14, 1, 10, 10
        windowlocate 11, 5
        windowprint 1, "Initial Infiltration Rate (in/hr)"
        EditFieldOpen 9, a$(9), 11, 55, 14, 1, 10, 10
        windowlocate 12, 5
        windowprint 1, "Horton Depletion Coefficient (/hr)"
        EditFieldOpen 10, a$(10), 12, 55, 14, 1, 10, 10
        EditFields = 10
END IF
IF w.InfMeth = 3 THEN
        IF w.CN <> 0 THEN a$(8) = STR$(w.CN) ELSE a$(8) = ""
        IF w.InitAbs <> 0 THEN a$(9) = STR$(w.InitAbs) ELSE a$(9) = ".2"
        MaxField = 9
        windowlocate 10, 5
        windowprint 1, "SCS Curve Number (for Pervious)"
        EditFieldOpen 8, a$(8), 10, 55, 14, 1, 10, 10
        windowlocate 11, 5
        windowprint 1, "SCS Abstraction Factor"
        EditFieldOpen 9, a$(9), 11, 55, 14, 1, 10, 10
        EditFields = 9
END IF
windowline 13
IF ControlEditWindow(EditFields, 14, help$) = FALSE THEN EXIT SUB

w.TotalArea = VAL(EditFieldInquire(1))
w.TimeCon = VAL(EditFieldInquire(2))
w.ImpArea = VAL(EditFieldInquire(3))
w.DCIA = VAL(EditFieldInquire(4))
w.AddAbsImp = VAL(EditFieldInquire(5))
w.addabsPerv = VAL(EditFieldInquire(6))
w.MaxInf = VAL(EditFieldInquire(7))

SELECT CASE w.InfMeth
CASE 2
        w.HIC = VAL(EditFieldInquire(8))
        w.HIO = VAL(EditFieldInquire(9))
        w.HK = VAL(EditFieldInquire(10))
CASE 3
        w.CN = VAL(EditFieldInquire(8))
        w.InitAbs = VAL(EditFieldInquire(9))

END SELECT

WindowClose 1

IF w.ImpArea > w.TotalArea THEN
        a$ = "Your Impervious area exceeds your Total area."
        a$ = a$ + "|Please correct before you continue"
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        GOTO StartofEditShedFile
END IF
IF w.TimeCon <= 0 THEN
        a$ = "Your time of concentration must be greater than 0"
        a$ = a$ + "|Please correct before you continue"
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        GOTO StartofEditShedFile
END IF
IF w.TotalArea <= 0 THEN
        a$ = "Your watershed area must be greater than 0."
        a$ = a$ + "|Please correct before you continue"
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        GOTO StartofEditShedFile
END IF

IF w.CN <= 20 AND w.InfMeth = 3 THEN
        a$ = "Your SCS Curve Number must be greater than 20."
        a$ = a$ + "|Please correct before you continue"
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        GOTO StartofEditShedFile
END IF
IF w.DCIA > 100 THEN
        a$ = "Your Percent Impervious Directly Connected"
        a$ = a$ + "|must be less than 100."
        a$ = a$ + "|Please correct before you continue"
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        GOTO StartofEditShedFile
END IF

ShedCalc w

END SUB

DEFSNG Z
SUB EditStorDisrel (pond AS pondtype)

StartofEditStorDisrel:

IF pond.minstage = 0 THEN dummy$ = "" ELSE dummy$ = STR$(pond.minstage)
pond.minstage = VAL(GetLabel$(dummy$, "Minimum stage for relationships"))
IF pond.numstordisrel = 0 THEN dummy$ = "" ELSE dummy$ = STR$(pond.numstordisrel)
pond.numstordisrel = VAL(GetLabel$(dummy$, "How Many Relationships"))
IF pond.numstordisrel = 0 THEN EXIT SUB
IF pond.stageint = 0 THEN dummy$ = "1" ELSE dummy$ = STR$(pond.stageint)
pond.stageint = VAL(GetLabel$(dummy$, "Input Increment of Relationships (ft)"))
IF pond.stageint = 0 THEN EXIT SUB

IF pond.initstage < pond.minstage THEN dummy$ = STR$(pond.minstage) ELSE dummy$ = STR$(pond.initstage)
pond.initstage = VAL(GetLabel$(dummy$, "Input initial pond stage (ft)"))
IF pond.initstage < pond.minstage THEN
        a1$ = "Your intitial pond stage of " + STR$(pond.initstage) + " must be above"
        a1$ = a1$ + "|your minimum stage for stage storage relations of " + STR$(pond.minstage)
        dummy = Alert(4, a1$, 10, 10, 16, 70, "", "Continue", "")
        GOTO StartofEditStorDisrel
END IF


StartofStorDisrel:

WindowOpen 1, 4, 5, 8 + pond.numstordisrel, 75, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, ""

windowlocate 1, 4
windowprint -1, "Stage(ft)       Storage (acre-feet)       Discharge (cfs)"
windowline 2
FOR i = 1 TO pond.numstordisrel
        windowlocate 2 + i, 6
        pond.stage(i) = pond.minstage + (i - 1) * pond.stageint
        windowprint -1, STR$(pond.stage(i))
        IF pond.storage(i) = 0 THEN a$ = "" ELSE a$ = STR$(pond.storage(i))
        IF i = 1 THEN a$ = "0"
        IF pond.discharge(i) = 0 THEN b$ = "" ELSE b$ = STR$(pond.discharge(i))
        EditFieldOpen 1 + (i - 1) * 2, a$, i + 2, 25, 14, 1, 10, 10
        EditFieldOpen 2 + (i - 1) * 2, b$, i + 2, 45, 14, 1, 10, 10
NEXT i
windowlocate i + 2, 10
windowprint -1, "Cumulative volume above initial stage"
StorFlag = ControlEditWindow(pond.numstordisrel * 2, 5 + pond.numstordisrel, help$)
IF StorFlag = 0 THEN EXIT SUB

FOR i = 1 TO pond.numstordisrel
        pond.storage(i) = VAL(EditFieldInquire(1 + (i - 1) * 2))
        pond.discharge(i) = VAL(EditFieldInquire(2 + (i - 1) * 2))
NEXT i
WindowClose 1

' *******               Check For Consistency of data   ********

continueFlag = TRUE

FOR i = 1 TO pond.numstordisrel - 1
        IF pond.storage(i) > pond.storage(i + 1) THEN
             continueFlag = FALSE
             bad$ = " Storage "
             BadRel1! = pond.stage(i): BadStorage1! = pond.storage(i)
             BadRel2! = pond.stage(i + 1): BadStorage2! = pond.storage(i + 1)
        END IF
        IF pond.discharge(i) > pond.discharge(i + 1) THEN
             continueFlag = FALSE
             bad$ = " Discharge "
             BadRel1! = pond.stage(i): BadStorage1! = pond.storage(i)
             BadRel2! = pond.stage(i + 1): BadStorage2! = pond.storage(i + 1)
       END IF
NEXT i
IF continueFlag = FALSE THEN
        a1$ = "Your Storage and Discharge must increase with increasing"
        a1$ = a1$ + "|stage, please correct this relationship."
        a1$ = a1$ + "|Bad" + bad$ + "Between stages " + STR$(BadRel1!) + " and " + STR$(BadRel2!)
        a1$ = a1$ + "| Entered Relations: " + STR$(BadStorage1!) + " and " + STR$(BadStorage2!)
        dummy = Alert(4, a1$, 10, 10, 17, 70, "", "Continue", "")
END IF

'       ********        Save File If User Specifies     **********

IF StorFlag <> 0 THEN
        
        a1$ = "This relationship must be saved to be used in routing."
        a1$ = a1$ + "|Save this relationship?"
        a = Alert(4, a1$, 10, 10, 13, 70, "Yes", "No", "")
        IF a = 1 THEN SaveStorDisrel pond
END IF


END SUB

