DEFINT A-Y

' ===========================================================================
'
' SMOUT.BAS Copyright (c) 1992 EAGLIN   -  SMADA Output Routines
'
' ===========================================================================

'$INCLUDE: 'smada.bi'

DECLARE SUB PrintOrderForm (b$)
DECLARE FUNCTION routeprint% ()
DECLARE SUB colordisplay ()
DECLARE SUB RoutePrintToSub (menu AS INTEGER, item AS INTEGER, w AS watershedtype, r AS rainfalltype, h AS hydrographtype, pond AS pondtype, p() AS pondtype, n AS nodetype)
DECLARE SUB GetSaveFileName ()
DECLARE SUB PrintHydrograph (h AS hydrographtype, r AS rainfalltype)
DECLARE SUB PrintRainFile (r AS rainfalltype)

DECLARE SUB PlotHydrograph (h AS hydrographtype, r AS rainfalltype)
DECLARE SUB DeleteFile (FileSpec$)
DECLARE SUB RetrieveHydroFile (h AS hydrographtype, r AS rainfalltype)
DECLARE SUB RetrieveRainFile (r AS rainfalltype)
DECLARE SUB RetrieveShedFile (w AS watershedtype)
DECLARE SUB RetrieveStorDisRel (pond AS pondtype)
DECLARE SUB SaveBatchData (n AS nodetype)
DECLARE SUB SaveHydroFile (h AS hydrographtype, r AS rainfalltype)
DECLARE SUB SaveRainFile (r AS rainfalltype)
DECLARE SUB SaveShedFile (w AS watershedtype)
DECLARE SUB SaveStorDisrel (pond AS pondtype)
'       Watershed Manipulation Subroutines

DECLARE SUB PrintWatershed (w AS watershedtype)
DECLARE SUB PrintNode (p() AS pondtype, r AS rainfalltype, n AS nodetype)

DECLARE FUNCTION GetNode% (Message$, FlowToFlag%, ActiveFlag%, n AS nodetype)
DECLARE SUB ShedCalc (w AS watershedtype)
DECLARE FUNCTION FileRetrieve$ (FileSpec$)
DECLARE FUNCTION GetFileCount% (FileSpec$)

DECLARE FUNCTION GetLabel$ (default$, Message$)
DECLARE FUNCTION MultAnswer (n%, a$(), title$)
DECLARE FUNCTION GetAnswer (n%, a$(), title$)
DECLARE SUB PlotAxis (xmax!, ymax!)
DECLARE SUB PlotNode (r AS rainfalltype, n AS nodetype)
DECLARE SUB HyetoPlot (xmax!, h AS hydrographtype, r AS rainfalltype)
DECLARE SUB PlotSeries (Steps%, Stepsmax%, Valy!(), ymax!, r AS rainfalltype)

'$INCLUDE: 'general.bi'
'$INCLUDE: 'mouse.bi'
'$INCLUDE: 'menu.bi'
'$INCLUDE: 'window.bi'

COMMON SHARED /uitools/ GloMenu           AS MenuMiscType
COMMON SHARED /uitools/ GloTitle()        AS MenuTitleType
COMMON SHARED /uitools/ GloItem()         AS MenuItemType
COMMON SHARED /uitools/ GloWindow()       AS windowType
COMMON SHARED /uitools/ GloButton()       AS buttonType
COMMON SHARED /uitools/ GloEdit()         AS EditFieldType
COMMON SHARED /uitools/ GloStorage        AS WindowStorageType
COMMON SHARED /uitools/ GloWindowStack()  AS INTEGER
COMMON SHARED /uitools/ GloBuffer$()


COMMON SHARED CurrentPath$
COMMON SHARED SaveFileName$
COMMON SHARED label$
COMMON SHARED HydroFile$
COMMON SHARED WaterFile$
COMMON SHARED RainFile$

COMMON SHARED bar$
COMMON SHARED Message$

DIM GloTitle(MAXMENU)           AS MenuTitleType
DIM GloItem(MAXMENU, MAXITEM)   AS MenuItemType
DIM GloWindow(MAXWINDOW)        AS windowType
DIM GloButton(MAXBUTTON)        AS buttonType
DIM GloEdit(MAXEDITFIELD)       AS EditFieldType
DIM GloWindowStack(MAXWINDOW)   AS INTEGER
DIM GloBuffer$(MAXWINDOW + 1, 2)
DIM SHARED DisplayType          AS INTEGER

SUB DeleteFile (FileSpec$)
RFile$ = FileRetrieve(FileSpec$)
IF RFile$ <> "" THEN
        a$ = RFile$ + " Will be Deleted"
        junk = Alert(4, a$, 10, 20, 15, 60, "Delete", "Cancel", "")
        IF junk = 1 THEN KILL RFile$
END IF
END SUB

FUNCTION FileRetrieve$ (FileSpec$)
        delimit = INSTR(FileSpec$, ".")

    IF delimit THEN
        fileName$ = LEFT$(FileSpec$, delimit - 1)
        fileExt$ = RIGHT$(FileSpec$, LEN(FileSpec$) - (delimit))
    ELSE
        fileName$ = FileSpec$
        fileExt$ = ""
    END IF

    IF LEN(FileSpec$) = 0 OR LEN(fileName$) > 8 OR LEN(fileExt$) > 3 THEN
        EXIT FUNCTION
    END IF

    FileCount = GetFileCount(FileSpec$)

    IF FileCount THEN

        REDIM FileList$(FileCount)

    ELSE

        junk = Alert(4, "No match to your file specification could be found.", 10, 10, 12, 70, "OK", "", "")
        EXIT FUNCTION
    END IF

    FileList$(1) = DIR$(FileSpec$)

    FOR Indx = 2 TO FileCount
        FileList$(Indx) = DIR$
    NEXT Indx

    x = ListBox(FileList$(), UBOUND(FileList$))

    FileRetrieve$ = FileList$(x)
    WindowClose 1
END FUNCTION

DEFINT Z
FUNCTION GetFileCount (FileSpec$)
    count = 0
    fileName$ = DIR$(FileSpec$)
    DO WHILE fileName$ <> ""
        count = count + 1
        fileName$ = DIR$
    LOOP
    GetFileCount = count
END FUNCTION

DEFSNG Z
SUB PlotNode (r AS rainfalltype, n AS nodetype)
DIM PlotN(MAXNODES)
DIM InSteps(MAXNODES)
DIM OutSteps(MAXNODES)
DIM flow!(MAXSTEPS)
DIM flow2!(MAXSTEPS)
REDIM a$(MAXNODES)
DIM b$(2)
DIM a(MAXNODES)

ContinueFlag = FALSE
FOR i = 1 TO MAXNODES
        IF n.NodeExist(i) = TRUE THEN ContinueFlag = TRUE
NEXT i
IF ContinueFlag = FALSE THEN
        a1$ = "There are no nodes defined. To save data you first"
        a1$ = a1$ + "|must define and link your nodes."
        junk = Alert(4, a1$, 10, 10, 16, 70, "", "Continue", "")
        EXIT SUB
END IF


b$(1) = "No"
b$(2) = "Yes"

ExitFlag = FALSE

WHILE NOT ExitFlag
        dummy = GetNode("Choose Node To Plot", FALSE, FALSE, n)
        IF dummy <> 0 THEN PlotN(dummy) = TRUE ELSE EXIT SUB
        junk = GetAnswer(2, b$(), "Plot another on same plot?")
        IF junk = 1 THEN ExitFlag = TRUE
     
WEND

Stepsmax = VAL(GetLabel$("200", "Choose Number of steps to plot < 220"))
IF Stepsmax = 0 OR Stepsmax > MAXSTEPS - 1 THEN Stepsmax = MAXSTEPS - 1

FOR i = 1 TO MAXNODES
        IF PlotN(i) = TRUE THEN
                FOR j = 1 TO Stepsmax
                        IF n.NodeInflow(i, j) > NodalMax! THEN NodalMax! = n.NodeInflow(i, j)
                        IF n.NodeOutflow(i, j) > NodalMax! THEN NodalMax! = n.NodeOutflow(i, j)
                NEXT j
        END IF
NEXT i


PlotAxis CSNG(r.RainTimeStep * Stepsmax), NodalMax!

FOR i = 1 TO MAXNODES
        IF PlotN(i) = TRUE THEN
                FOR j = 1 TO Stepsmax
                        flow!(j) = n.NodeInflow(i, j)
                NEXT j
                FOR j = 1 TO Stepsmax
                        flow2!(j) = n.NodeOutflow(i, j)
                NEXT j

        PlotSeries Stepsmax, Stepsmax, flow!(), NodalMax!, r
        PlotSeries Stepsmax, Stepsmax, flow2!(), NodalMax!, r
        END IF
NEXT i

DO
        c$ = INKEY$
        MousePoll r1, c, lb, rb
LOOP UNTIL c$ <> "" OR lb OR rb

SCREEN 0, 0, 0

MenuShow
MouseShow
colordisplay

END SUB

SUB PrintNode (p() AS pondtype, r AS rainfalltype, n AS nodetype)

REDIM a$(MAXNODES)
ContinueFlag = FALSE
FOR i = 1 TO MAXNODES
        IF n.NodeExist(i) = TRUE THEN ContinueFlag = TRUE
NEXT i
IF ContinueFlag = FALSE THEN
        a1$ = "There are no nodes defined. To save data you first"
        a1$ = a1$ + "|must define and link your nodes."
        junk = Alert(4, a1$, 10, 10, 16, 70, "", "Continue", "")
        EXIT SUB
END IF

a = routeprint
IF a = FALSE THEN EXIT SUB
DummyNode = GetNode("Choose Node to Print", FALSE, FALSE, n)
IF DummyNode = 0 THEN EXIT SUB ELSE ActiveNode = DummyNode

IF a = 3 THEN CLS
page = 1
i = 1
PRINT #1, "(Node "; ActiveNode; ") "; RTRIM$(n.NodeLabel(ActiveNode)); " Flowing To "; RTRIM$(n.NodeLabel(n.FlowTo(ActiveNode))); " (Node "; n.FlowTo(ActiveNode); ")";
PRINT #1, TAB(62); " SMADA PAGE "; page

' ******   Set a$ and b$ for correct node type

SELECT CASE n.nodetype(ActiveNode)
        CASE 1: a$ = " Watershed Node"
        CASE 3: a$ = " Junction Node"
        CASE 5: a$ = " Batch Node"
END SELECT
IF n.NodeGeometry(ActiveNode) = 1 THEN
        b$ = " Circular Outlet "
ELSEIF n.NodeGeometry(ActiveNode) = 2 THEN
        b$ = " Trapezoidal Outlet "
END IF
IF n.nodetype(ActiveNode) = 2 THEN
        a$ = " Pond Node:"
        b$ = "Output by Storage Discharge Relationship"
END IF




PRINT #1, TAB(10); a$; b$

'       *****   Printout of

IF (n.nodetype(ActiveNode) = 5 OR n.nodetype(ActiveNode) = 1 OR n.nodetype(ActiveNode) = 3) AND n.NodeGeometry(ActiveNode) <> 3 THEN
        PRINT #1, TAB(10);
        PRINT #1, USING " Length = ####.# ft"; n.Length(ActiveNode);
        PRINT #1, USING "  Longitudinal Slope = #.###"; n.Slope(ActiveNode)
        PRINT #1, TAB(10);
        PRINT #1, USING "  Velocity (at full flow conditions) = ###.## fps"; n.Velocity(ActiveNode)
        PRINT #1, TAB(10);
        IF n.NodeGeometry(ActiveNode) = 1 THEN
                PRINT #1, USING "Diameter = ##.## ft"; n.Diameter(ActiveNode);
        ELSEIF n.NodeGeometry(ActiveNode) = 2 THEN
                PRINT #1, USING "Base = ##.## ft"; n.Diameter(ActiveNode);
                PRINT #1, USING "  Side v/h = #.##"; n.SideSlope(ActiveNode);
                PRINT #1, USING "  Max Depth = ##.## ft"; n.Depth(ActiveNode)
        END IF

' *****      Printout of Pond Stage Storage   ********

ELSEIF n.nodetype(ActiveNode) = 2 THEN
        PRINT #1, TAB(10);
        PRINT #1, USING "Maximum Volume = ####.## acre-feet   Maximum Stage = ####.## ft"; p(ActiveNode).maxvolume / 43560; p(ActiveNode).MaxStage
        PRINT #1, TAB(10);
        PRINT #1, USING "Average Detention Time = ####.## hours"; p(ActiveNode).tdsum
        IF p(ActiveNode).numstordisrel <> 0 THEN
                PRINT #1,
                PRINT #1, TAB(10); " Stage - Storage - Discharge Relationship "
                PRINT #1, TAB(10); "Stage (ft)      Storage (Acre-ft)    Discharge (cfs)"
                FOR i = 1 TO p(ActiveNode).numstordisrel
                        PRINT #1, TAB(10);
                        PRINT #1, USING " #####.##        ####.##          ####.##"; p(ActiveNode).stage(i); p(ActiveNode).storage(i); p(ActiveNode).discharge(i)
                NEXT i
                PRINT #1,
        END IF

END IF

IF a = 3 THEN WHILE INKEY$ = "": WEND: CLS
IF a = 1 THEN PRINT CHR$(12)

page = 2
GOSUB NodePrintHeader
i = 1
ExitFlag = FALSE
WHILE NOT ExitFlag
        
        IF a = 3 AND i / 18! = INT(i / 18!) THEN
                page = page + 1
                GOSUB NodePrintHeader
        END IF
        IF a = 1 AND i / 50! = INT(i / 50!) THEN
                page = page + 1
                GOSUB NodePrintHeader
        END IF
        SumOfLastPage! = SumOfLastPage! + n.NodeInflow(ActiveNode, i) + n.NodeOutflow(ActiveNode, i)
        PRINT #1, USING "        ###.##"; i * r.RainTimeStep / 60;
        PRINT #1, USING "       ###.##"; n.NodeInflow(ActiveNode, i);
        PRINT #1, USING "              ###.##"; n.NodeOutflow(ActiveNode, i);
        IF n.nodetype(ActiveNode) = 2 THEN PRINT #1, USING "          ###.##"; p(ActiveNode).pstage(i) ELSE PRINT #1,
        i = i + 1
        IF i = MAXSTEPS - 1 THEN ExitFlag = TRUE
WEND
CLOSE #1
colordisplay
EXIT SUB
NodePrintHeader:
        IF a = 3 AND page > 2 THEN
                WHILE INKEY$ = "": WEND: CLS
        END IF
        IF a = 1 THEN PRINT #1, CHR$(12)
        IF SumOfLastPage! = 0 AND page > 2 THEN ExitFlag = -1
        SumOfLastPage! = 0
        PRINT #1, TAB(10); "Node : "; ActiveNode; " - "; n.NodeLabel(ActiveNode);
        PRINT #1, TAB(61); "SMADA PAGE "; page
        PRINT #1, TAB(10); "Time(hr)    Inflow (cfs)       Outflow(cfs)";
        IF n.nodetype(ActiveNode) = 2 THEN PRINT #1, "    Stage (ft)" ELSE PRINT #1,
        PRINT #1, bar$

RETURN

END SUB

DEFINT Z
SUB PrintOrderForm (b$)
a = routeprint
IF a = 0 THEN EXIT SUB
IF a = 3 THEN CLS
OPEN b$ FOR INPUT AS #2
        i = 1
        WHILE NOT EOF(2)
                LINE INPUT #2, a$
                PRINT #1, a$
                i = i + 1
                IF i / 20! = INT(i / 20) AND a = 3 THEN WHILE INKEY$ = "": WEND
        WEND

        IF a = 3 THEN WHILE INKEY$ = "": WEND
        IF a = 1 THEN PRINT #1, CHR$(12)
CLOSE #1
CLOSE #2
END SUB

DEFSNG Z
SUB PrintRainFile (r AS rainfalltype)
r.TotalRain = 0
IF r.RainTimeStep = 0 THEN
        a$ = "No Rainfall in current Memory"
        junk = Alert(4, a$, 9, 10, 14, 70, "", "", "")
        EXIT SUB
END IF
a = routeprint

IF a = FALSE THEN EXIT SUB
GOSUB RainfallHeader
FOR i = 1 TO r.NumRainSteps
        IF a = 3 AND i / 18! = INT(i / 18!) THEN
                WHILE INKEY$ = "": WEND
                GOSUB RainfallHeader
        END IF
        r.TotalRain = r.TotalRain + r.Rain(i)
        PRINT #1, TAB(12);
        PRINT #1, USING "#####"; i * r.RainTimeStep;
        PRINT #1, USING "         ####.##"; r.Rain(i)
NEXT i
PRINT #1, bar$
PRINT #1, TAB(12); "Total Rain = ";
PRINT #1, USING "###.## inches"; r.TotalRain;
IF a = 3 THEN WHILE INKEY$ = "": WEND
CLOSE
colordisplay
EXIT SUB

RainfallHeader:
        IF a = 3 THEN CLS
        PRINT #1, TAB(12); "Time          Rainfall"
        PRINT #1, TAB(12); "(min)           (in)"
        PRINT #1, bar$

RETURN

END SUB

SUB PrintWatershed (w AS watershedtype)

IF w.infmeth = 0 THEN
        a$ = "You must create or retrieve a watershed before printing"
        a$ = a$ + "|use Create or Retrieve Watershed"
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        EXIT SUB
END IF

a = routeprint
IF a = FALSE THEN EXIT SUB
label$ = GetLabel$("", "Enter Print Label for Watershed")
IF a = 3 THEN CLS
PRINT #1, TAB(15); "SMADA 4.0   Watershed Information for: "; label$
PRINT #1, bar$
PRINT #1, USING "        Total Watershed area ###.# acres"; w.TotalArea
PRINT #1, USING "        Total Impervious area ###.# acres"; w.ImpArea
PRINT #1, USING "        Total Percent impervious area which is directly connected: ###.# %"; w.DCIA
PRINT #1, USING "        Time of concentration: ### minutes"; w.TimeCon
PRINT #1, "        Additional Abstraction for different area types"
PRINT #1, USING "        Pervious #.## inches     Impervious #.## inches"; w.addabsPerv; w.AddAbsImp
PRINT #1, bar$
IF w.infmeth = 2 THEN
        PRINT #1, "        Infiltration Calculated by Horton Method"
        PRINT #1, USING "        Initial Infiltration Rate ##.## in/hr"; w.HIO
        PRINT #1, USING "        Limiting Infiltration Rate ##.## in/hr"; w.HIC
        PRINT #1, USING "        Depletion Coefficient ##.## hr^-1"; w.HK
ELSE
        PRINT #1, "        Infiltration Calculated by SCS Curve Number Method"
        PRINT #1, USING "        Pervious Curve Number: ##"; w.CN
        PRINT #1, USING "        Initial Abstraction Factor: #.##"; w.InitAbs
END IF
PRINT #1, bar$
IF a = 1 THEN PRINT #1, CHR$(12)
CLOSE
IF a = 3 THEN WHILE INKEY$ = "": WEND
colordisplay
END SUB

SUB RetrieveBatchNode (h AS hydrographtype, r AS rainfalltype, n AS nodetype)
a$ = "A Batch Node is Data which is input by hand to a file|"
a$ = a$ + "on a disk which has an extension of .DAT   For more|"
a$ = a$ + "information on using batch data nodes read the message|"
a$ = a$ + "in the on-line help under Batch-Data"

junk = Alert(4, a$, 5, 5, 11, 75, "Continue", "Cancel", "")
IF r.RainTimeStep = 0 THEN r.RainTimeStep = VAL(GetLabel$("", "What is the Time step?"))
IF junk <> 1 THEN EXIT SUB
RFile$ = FileRetrieve$("*.dat")
IF RFile$ <> "" THEN
        OPEN RFile$ FOR INPUT AS #1
        i = 1
        WHILE NOT EOF(1) AND i < MAXSTEPS
                INPUT #1, n.NodeInflow(ActiveNode, i)
                i = i + 1
        WEND
        CLOSE #1
        h.HydroSteps = i - 1
END IF

END SUB

DEFINT Z
SUB RetrieveRainFile (r AS rainfalltype)
RFile$ = FileRetrieve$("*.rnf")
RainFile$ = RFile$
IF RFile$ <> "" THEN
    OPEN RFile$ FOR INPUT AS #1
    INPUT #1, r.NumRainSteps, r.RainDuration, r.RainTimeStep
    FOR i = 1 TO r.NumRainSteps
    INPUT #1, r.Rain(i)
    NEXT i
    CLOSE #1
END IF
END SUB

DEFSNG Z
SUB RetrieveStorDisRel (pond AS pondtype)
RFile$ = FileRetrieve$("*.pnd")
IF RFile$ <> "" THEN
    OPEN RFile$ FOR INPUT AS #1
    INPUT #1, pond.numstordisrel, pond.minstage, pond.initstage, pond.stageint
    FOR i = 1 TO pond.numstordisrel
        INPUT #1, pond.storage(i), pond.discharge(i)
         pond.stage(i) = pond.minstage + (i - 1) * pond.stageint
    NEXT i
    CLOSE #1
END IF

END SUB

FUNCTION routeprint ()
DIM a$(3)
a$(1) = "Printer"
a$(2) = "Disk"
a$(3) = "Screen"
route = GetAnswer(3, a$(), "Choose Print Destination")

SELECT CASE route
        CASE 0: routeprint = FALSE: EXIT FUNCTION
        CASE 1:  OPEN "lpt1:" FOR OUTPUT AS #1
        CASE 2
                GetSaveFileName
                IF SaveFileName$ <> "" THEN
                        OPEN SaveFileName$ + ".prn" FOR OUTPUT AS #1
                END IF
        CASE 3: OPEN "scrn:" FOR OUTPUT AS #1
END SELECT
routeprint = route
END FUNCTION

SUB RoutePrintToSub (menu AS INTEGER, item AS INTEGER, w AS watershedtype, r AS rainfalltype, h AS hydrographtype, pond AS pondtype, p() AS pondtype, n AS nodetype)
    SELECT CASE menu
        CASE 1
            SELECT CASE item
                CASE 1:
                CASE 2:
                CASE 3:
                CASE 5:
            END SELECT
        CASE 2
            SELECT CASE item
                CASE 1:
                CASE 2:
                CASE 3: RetrieveShedFile w
                CASE 4: SaveShedFile w
                CASE 5: DeleteFile ("*.shd")
                CASE 6: PrintWatershed w
            END SELECT
        CASE 3
            SELECT CASE item
                CASE 1:
                CASE 2:
                CASE 3: RetrieveRainFile r
                CASE 4: SaveRainFile r
                CASE 5: DeleteFile ("*.rnf")
                CASE 6:
                CASE 7: PrintRainFile r
            END SELECT
        CASE 4
            SELECT CASE item
                CASE 1:
                CASE 2:
                CASE 3: RetrieveHydroFile h, r
                CASE 4: SaveHydroFile h, r
                CASE 5: PlotHydrograph h, r
                CASE 6: PrintHydrograph h, r
            END SELECT
        CASE 5
            SELECT CASE item
                CASE 1:
                CASE 2:
                CASE 3: RetrieveStorDisRel pond
                CASE 4: SaveStorDisrel pond
            END SELECT
        CASE 6
            SELECT CASE item
                CASE 1:
                CASE 2:
                CASE 3: SaveBatchData n
                CASE 4:
                CASE 5: PlotNode r, n
                CASE 6: PrintNode p(), r, n
                CASE 7:
                CASE 8:
            END SELECT
        CASE 7
            SELECT CASE item
                CASE 1: PrintOrderForm ("ORDER.FRM")
                        colordisplay
                CASE 2: PrintOrderForm ("ABOUT.FRM")
                        colordisplay
            END SELECT
        CASE ELSE
    END SELECT

END SUB

SUB SaveBatchData (n AS nodetype)
ContinueFlag = FALSE
FOR i = 1 TO MAXNODES
        IF n.NodeExist(i) = TRUE THEN ContinueFlag = TRUE
NEXT i
IF ContinueFlag = FALSE THEN
        a1$ = "There are no nodes defined. To save data you first"
        a1$ = a1$ + "|must define and link your nodes."
        junk = Alert(4, a1$, 10, 10, 16, 70, "", "Continue", "")
        EXIT SUB
END IF



ActiveNode = GetNode("Which Node to Output", FALSE, FALSE, n)
IF ActiveNode = 0 THEN EXIT SUB
GetSaveFileName
IF SaveFileName$ = "" THEN EXIT SUB
BatFile$ = SaveFileName$ + ".dat"
    OPEN BatFile$ FOR OUTPUT AS #1
    FOR i = 1 TO MAXSTEPS
        PRINT #1, n.NodeOutflow(ActiveNode, i)
    NEXT i
    CLOSE #1

END SUB

SUB SaveStorDisrel (pond AS pondtype)
IF pond.numstordisrel = 0 THEN
        a$ = "There is no pond in current memory. Please create"
        a$ = a$ + "|a pond before attempting to save."
        dummy = Alert(4, a$, 10, 10, 16, 70, "", "Continue", "")
        EXIT SUB
END IF
        

GetSaveFileName
IF SaveFileName$ = "" THEN EXIT SUB
RFile$ = SaveFileName$ + ".pnd"
    OPEN RFile$ FOR OUTPUT AS #1
    PRINT #1, pond.numstordisrel, , pond.minstage, pond.initstage, pond.stageint
    FOR i = 1 TO pond.numstordisrel
        PRINT #1, pond.storage(i), pond.discharge(i)
    NEXT i
CLOSE #1

END SUB

